<?php

// Website version.
define('SITE_VERSION', '3.1.1');

/*
	The Adminpanel class handles all Admin actions, permissions and admin dashboard.
*/

class Adminpanel extends MY_controller
{
	public $data = array();

	public function __construct ()
	{
		parent::__construct();
		// you can change the name page from the url from here
		$this->data['page_path'] = strtolower(__CLASS__);
		$this->isAdmin();
	}

	private function isAdmin()
	{
		$admintoken = $this->session->admin_token;

		if ($admintoken == '' && $this->uri->segment(2) != 'login')
		{
			$this->session->unset_userdata('admin_token');
			redirect(base_url($this->data['page_path'].'/login'));
		}
		else if ($admintoken != '' && $this->uri->segment(2) != 'login')
		{
			// get the admin data from users tabel
	        $q = $this->cms_model->select('users',array('user_status'=>1,'user_token'=>$admintoken,'user_verified'=>1));
	        if ($q->num_rows() == 1)
	        {
	            $a = $q->result_array();
	            $this->data['userdata'] = $a[0];

	            // get the admin data from usersmata tabel
				$sel = $this->cms_model->select('usersmeta',array('user_id'=>$a[0]['id']));
				$r = $sel->result_array();

				foreach ($r as $k => $row)
				{
					$this->data['userdata'][$row['user_option']] = $row['user_value'];
				}
	        }
	        else
	        {
	        	$this->session->unset_userdata('admin_token');
	        	redirect(base_url($this->data['page_path'].'/login'));
	        }
		}
	}

	public function index ()
	{
		$duration = 30; // 30 days (default)

		$duration = $this->input->get('d')? $this->input->get('d', true) : $duration;

		if (intval($duration)) // 30, 60, 365 (1 year)
		{
			$formated_duration = "P".intval($duration)."D";
			//echo get_datetime_from_now($formated_duration);
			// get all total Users' earnings (30 days)
			$total_users_earnings = $this->db->select_sum('earnings', 'total_earnings')
												->where('user_joined >=', get_datetime_from_now($formated_duration))
												->get('users')
												->first_row()
												->total_earnings;

			$users_earnings = $this->db->select("SUM(earnings) AS count")
												->where([
													'created >=' => get_datetime_from_now($formated_duration),
												])
												->get('stats')
												->first_row()
												->count;

			// counting withdrawal reqs (30 days)
			$total_withdrawal_reqs = $this->db->select('COUNT(id) AS total_reqs')
												->where('created >=', get_datetime_from_now($formated_duration))
												->get('withdraw_reqs')
												->first_row()
												->total_reqs;

			$total_pending_withdrawal_reqs = $this->db->select('COUNT(id) AS total_reqs')
												->where([
													'status' => 0,
													'created >=' => get_datetime_from_now($formated_duration)
												])
												->get('withdraw_reqs')
												->first_row()
												->total_reqs;

			// counting users (30 days)
			$total_verified_users = $this->db->select("COUNT(id) AS count")
												->where([
													'user_verified' => 1,
													'user_joined >=' => get_datetime_from_now($formated_duration)
												])
												->get('users')
												->first_row()
												->count;

			$total_inverified_users = $this->db->select("COUNT(id) AS count")
												->where([
													'user_verified' => 0,
													'user_joined >=' => get_datetime_from_now($formated_duration)
												])
												->get('users')
												->first_row()
												->count;

			// counting links & links' views (30 days)
			$total_links = $this->db->select("COUNT(id) AS count")
												->where('created >=', get_datetime_from_now($formated_duration))
												->get('links')
												->first_row()
												->count;

			$total_banned_links = $this->db->select("COUNT(id) AS count")
												->where([
													'status' => 0,
													'created >=' => get_datetime_from_now($formated_duration)
												])
												->get('links')
												->first_row()
												->count;

			$total_links_views = $this->db->select("SUM(views) AS count")
												->where('created >=', get_datetime_from_now($formated_duration))
												->get('stats')
												->first_row()
												->count;

			// Top 10 countries (30 days).
			$top_countries = $this->db->select_sum('stats.views', 'total_views')
									->select_sum('stats.earnings', 'earnings')
									->select("stats.country_id, countries.name, countries.code")
									->from('stats')
									->join('countries', "countries.id=stats.country_id", 'inner')
									->where('stats.created >=', get_datetime_from_now($formated_duration))
									->group_by('stats.country_id')
									->order_by('total_views', 'DESC')
									->limit(10)->get()->result_object();

			$view_per_geo = $this->db->select_sum('stats.views', 'total_views')
									->select_sum('stats.earnings', 'earnings')
									->select("stats.country_id, countries.name, countries.code")
									->from('stats')
									->join('countries', "countries.id=stats.country_id", 'inner')
									->where('stats.created >=', get_datetime_from_now($formated_duration))
									->group_by('stats.country_id')
									->order_by('total_views', 'DESC')
									->get()->result_object();

			$views_per_domain = $this->db->select("COUNT(id) as total_links, domain")
										->where('created >=', get_datetime_from_now($formated_duration))
										->group_by('domain')
										->get('links')
										->result_object();

			// Views line graph (30 days)
			$views_over_time = $this->db->select("COUNT(views) AS total_views, created")
										->select_sum('stats.earnings', 'total_earnings')
										->where('created >=', get_datetime_from_now($formated_duration))
										->group_by('created')
										->order_by('created', 'ASC')
										->get('stats')
										->result_object();

			// Count Browsers, Devices, OS (30 days)
			$top_browsers = $this->db->select("COUNT(id) AS total_visitors, browser")
										->where('created >=', get_datetime_from_now($formated_duration))
										->group_by('browser')
										->order_by('total_visitors', 'DESC')
										->get('stats')
										->result_object();

			$top_devices = $this->db->select("COUNT(id) AS total_visitors, device")
										->where('created >=', get_datetime_from_now($formated_duration))
										->group_by('device')
										->order_by('total_visitors', 'DESC')
										->get('stats')
										->result_object();

			$top_os = $this->db->select("COUNT(id) AS total_visitors, os")
										->where('created >=', get_datetime_from_now($formated_duration))
										->group_by('os')
										->order_by('total_visitors', 'DESC')
										->get('stats')
										->result_object();

		}


		// ======================= All time =======================
		if ($this->input->get('d', true) === 'all')
		{
			// get all total Users' earnings
			$total_users_earnings = $this->db->select_sum('earnings', 'total_earnings')
												->get('users')
												->first_row()
												->total_earnings;

			$users_earnings = $this->db->select("SUM(earnings) AS count")
												->get('stats')
												->first_row()
												->count;

			// counting withdrawal reqs
			$total_withdrawal_reqs = $this->db->select('COUNT(id) AS total_reqs')
												->get('withdraw_reqs')
												->first_row()
												->total_reqs;

			$total_pending_withdrawal_reqs = $this->db->select('COUNT(id) AS total_reqs')
												->where('status', 0)
												->get('withdraw_reqs')
												->first_row()
												->total_reqs;
			// counting users
			$total_verified_users = $this->db->select("COUNT(id) AS count")
												->where('user_verified', 1)
												->get('users')
												->first_row()
												->count;

			$total_inverified_users = $this->db->select("COUNT(id) AS count")
												->where('user_verified', 0)
												->get('users')
												->first_row()
												->count;

			// counting links & links' views
			$total_links = $this->db->select("COUNT(id) AS count")
												->get('links')
												->first_row()
												->count;

			$total_banned_links = $this->db->select("COUNT(id) AS count")
												->where('status', 0)
												->get('links')
												->first_row()
												->count;

			$total_links_views = $this->db->select("SUM(views) AS count")
												->get('stats')
												->first_row()
												->count;
			// Top 10 countries.
			$top_countries = $this->db->select_sum('stats.views', 'total_views')
									->select_sum('stats.earnings', 'earnings')
									->select("stats.country_id, countries.name, countries.code")
									->from('stats')
									->join('countries', "countries.id=stats.country_id", 'inner')
									->group_by('stats.country_id')
									->order_by('total_views', 'DESC')
									->limit(10)->get()->result_object();

			$view_per_geo = $this->db->select_sum('stats.views', 'total_views')
									->select_sum('stats.earnings', 'earnings')
									->select("stats.country_id, countries.name, countries.code")
									->from('stats')
									->join('countries', "countries.id=stats.country_id", 'inner')
									->group_by('stats.country_id')
									->order_by('total_views', 'DESC')
									->get()->result_object();

			$views_per_domain = $this->db->select("COUNT(id) as total_links, domain")
										->group_by('domain')
										->get('links')
										->result_object();

			// Views line graph
			$views_over_time = $this->db->select("COUNT(views) AS total_views, created")
										->select_sum('stats.earnings', 'total_earnings')
										->group_by('created')
										->order_by('created', 'ASC')
										->limit(30)
										->get('stats')
										->result_object();

			// Count Browsers, Devices, OSes
			$top_browsers = $this->db->select("COUNT(id) AS total_visitors, browser")
										->group_by('browser')
										->order_by('total_visitors', 'DESC')
										->get('stats')
										->result_object();

			$top_devices = $this->db->select("COUNT(id) AS total_visitors, device")
										->group_by('device')
										->order_by('total_visitors', 'DESC')
										->get('stats')
										->result_object();

			$top_os = $this->db->select("COUNT(id) AS total_visitors, os")
										->group_by('os')
										->order_by('total_visitors', 'DESC')
										->get('stats')
										->result_object();


		}

		// online visitors
		$online_visitors = $this->db->select('COUNT(agent) as count')
											->get('online')
											->first_row()
											->count;
		// active withdrawal methods
		$total_withdrawal_active_methods = $this->db->select("COUNT(id) AS count")
											->where('status', 1) // active methods
											->get('withdrawal_methods')
											->first_row()
											->count;
		// get recent links
		$recent_links = $this->db->select('links.id, links.title, links.url, links.slug, links.domain, users.username, users.email, users.user_token')
						->select_sum('stats.views', 'total_views')
						->from('links')
						->join('stats', 'links.id = stats.link_id', 'left')
						->join('users', 'users.id = links.user_id', 'inner')
						->group_by('links.id')
						->order_by('links.created', 'DESC')
						->limit(15)
						->get()
						->result_object();

		// get recent users
		$recent_users = $this->db->order_by('id', 'DESC')->limit(15)->get('users')->result_object();

		$this->data['duration'] = $duration;
		// pass all stats to the views.
		$this->data['total_users_earnings'] = $total_users_earnings;
		$this->data['users_earnings'] = $users_earnings;
		$this->data['total_withdrawal_reqs'] = $total_withdrawal_reqs;
		$this->data['total_pending_withdrawal_reqs'] = $total_pending_withdrawal_reqs;
		$this->data['total_withdrawal_active_methods'] = $total_withdrawal_active_methods;
		$this->data['total_verified_users'] = $total_verified_users;
		$this->data['total_inverified_users'] = $total_inverified_users;
		$this->data['online_visitors'] = $online_visitors;
		$this->data['total_links'] = $total_links;
		$this->data['total_banned_links'] = $total_banned_links;
		$this->data['total_links_views'] = $total_links_views;
		$this->data['top_countries'] = $top_countries;
		$this->data['view_per_geo'] = $view_per_geo;
		$this->data['views_per_domain'] = $views_per_domain;
		$this->data['views_over_time'] = $views_over_time;
		$this->data['top_browsers'] = $top_browsers;
		$this->data['top_devices'] = $top_devices;
		$this->data['top_os'] = $top_os;
		$this->data['recent_links'] = $recent_links;
		$this->data['recent_users'] = $recent_users;


		/*==============================================================*/

		$this->data['title'] = 'Hello '.$this->data['userdata']['username'];

		$this->load->view('templates/admin_header',$this->data);
		$this->load->view('pages/admin/dashboard',$this->data);
		$this->load->view('templates/admin_footer',$this->data);
	}

	public function Dashboard ()
	{
		$this->index();
	}

	public function settings ()
	{
		$this->data['title'] = 'Site settings';
		$this->data['languages'] = $this->cms_model->select('languages')->result_array();

		$this->load->view('templates/admin_header',$this->data);
		$this->load->view('pages/admin/site_settings',$this->data);
		$this->load->view('templates/admin_footer',$this->data);
	}

	public function profile ()
	{
		$this->data['title'] = 'Profile';

		/*======================== Update admin profile ============================*/
		if ($this->input->post('edit-profile'))
		{
			$msg = "msg1";

			if (is_demo())
			{
				$ok = "Oops, This Action is not allowed on the Demo!";
			}
			else
			{
				$username 		= trim(strip_tags($this->input->post('username',TRUE)));
				$email 			= trim(strip_tags($this->input->post('email',TRUE)));
				$sec_ques 		= trim(strip_tags($this->input->post('security-question',TRUE)));
				$ans_ques 		= trim(strip_tags($this->input->post('answer-question',TRUE)));

				if (empty($username) or empty($email))
				{
					$err = "please fill the all fields !";
				}
				else if (!filter_var($email,FILTER_VALIDATE_EMAIL))
				{
					$err = "Your email is not correct !";
				}
				else
				{
					// update data of admin
					$admin_id = $this->data['userdata']['id'];
					$set['username'] = $username;
					$set['email'] = $email;
					$where = array('id'=>$admin_id,'user_status'=>1);

					$up = $this->cms_model->update('users',$set,$where);

					$a['sec_ques'] = $sec_ques;
					$a['ans_ques'] = $ans_ques;

					// delete all information from database by user_id
					foreach ($a as $k => $v) {

						$w['user_id'] = $admin_id;
						$w['user_option'] = $k;

						$del = $this->cms_model->delete('usersmeta',$w);
					}

					// insert all information to database
					$s = array();
					foreach ($a as $k => $v)
					{
						$d['user_id'] = $admin_id;
						$d['user_option'] = $k;
						$d['user_value'] = $v;

						$sel = $this->cms_model->insert('usersmeta',$d);
						if ($sel)
						{
							array_push($s,1);
						}
						else
						{
							array_push($s,0);
						}
					}

					if (in_array(0,$s))
					{
						$err = "Oops!, something went wrong!";
					}
					else
					{
						$ok = "Updated successfully";
					}

				}
			}


		} // end if block

		/*======================== Update password ============================*/
		if ($this->input->post('edit-pass'))
		{
			$msg = "msg2";

			if (is_demo())
			{
				$ok = "Oops, This Action is not allowed on the Demo!";
			}
			else
			{

				$old_pass 	= trim(strip_tags($this->input->post('old-pass',TRUE)));
				$new_pass 	= trim(strip_tags($this->input->post('new-pass',TRUE)));
				$conf_pass 	= trim(strip_tags($this->input->post('conf-new-pass',TRUE)));

				if ($old_pass == '' or $new_pass == '' or $conf_pass == '')
				{
					$err = "Please insert all information !";
				}
				else if (!password_verify($old_pass,$this->data['userdata']['password']))
				{
					$err = "The <b>old password</b> isn't correct !";
				}
				else if ($new_pass != $conf_pass)
				{
					$err = "The two passwords aren't matched.";
				}
				else
				{
					$set['password'] = password_hash($new_pass,PASSWORD_DEFAULT);
					$where = array('user_token'=>$this->data['userdata']['user_token']);

					$up = $this->cms_model->update('users',$set,$where);

					if ($up)
					{
						$ok = "The password changed successfully.";
					}
					else
					{
						$err = "Oops!, something went wrong!!";
					}
				}
			}

		} // end if

		if (isset($err) && $err != '')
		{
			$this->data[$msg] = "<div class='alert alert-warning'>".$err."</div>";
		}
		else if (isset($ok) && $ok != '')
		{
			$this->data[$msg] = "<div class='alert alert-success'>".$ok."</div>";
		}

		// Just for refreshing admin information.
		$this->isAdmin();

		$this->load->view('templates/admin_header',$this->data);
		$this->load->view('pages/admin/profile',$this->data);
		$this->load->view('templates/admin_footer',$this->data);
	}

	public function login ($action='')
	{
		if ($this->session->admin_token != '')
		{
			redirect(base_url(config_item('admin_page_path')));
		}

		if ($action == "")
		{
			$this->data['title'] = 'Admin login page !';
			$page = "login";
			$this->data['msg'] = $this->cms_model->login('admin');
		}
		else if ($action == 'forget_pass')
		{
			$this->data['title'] = 'Recovery my account !';
			$page = "forget_pass";

			$this->data['msg'] = $this->cms_model->forget_pass('admin');
		}
		else if ($action == 'repass')
		{
			$this->data['title'] = 'Set a new password';
			$page = 'repass';

	        $t = ($this->input->get('t',TRUE) != '')? $this->input->get('t',TRUE) : $this->input->post('t',TRUE) ;
	        $code = trim(strip_tags($t));

	        if ($code == "")
	        {
	            show_my_404();
	        }
	        else
	        {
	            $this->data['t'] = $code;
	            $a = explode("--",decode($code,TRUE));

	            if (isset($a[1]) && (time() < $a[1] + get_config_item('restoration_time_account') * 3600))
	            {
	                $this->data['msg'] = $this->cms_model->repass($a[0],'admin');
	            }
	            else
	            {
	                $this->data['forb'] = "<div class='alert alert-danger'><i class='fa fa-lg fa-clock-o'></i> Sorry this link is not available anymore !</div>";
	            }
	        }

		}

		$this->load->view('templates/head_login_admin',$this->data);
		$this->load->view('pages/admin/'.$page,$this->data);
		$this->load->view('templates/footer',$this->data);

	}

	public function users ($var='',$page=1)
	{
		$this->data['title'] = "Users";

		$search = trim(strip_tags($this->input->get('q_user',TRUE)));
		$this->data['string'] = $search;

		$where = array('user_status !='=>1);

		$num = ($this->input->get('num') != '')? abs(intval($this->input->get('num'))) : 20 ; // number of users at one page

		$page = trim(intval($page));
		$start = ($page - 1) * $num;

		if ($search)
		{
			$total_users = $this->db->select('COUNT(id) AS total_users')
						->where("MATCH (`username`, `email`, `user_token`) AGAINST ('\"{$search}\"' IN BOOLEAN MODE)")
						->get('users')
						->first_row()
						->total_users;
		}
		else
		{
			$total_users = $this->db->select('COUNT(id) AS total_users')
						->get('users')
						->first_row()
						->total_users;
		}

		$this->data['total_users'] = $total_users;
		$this->data['page'] = $page;
		$this->data['all_pages'] = ceil($total_users / $num);

		if ($page <= 0 or $page > ceil($total_users / $num))
		{
			$this->data['ops'] = "Ops, No data found !";
		}
		else
		{
			if ($search)
			{
				$s1 = $this->db->select('*')
						->where("MATCH (`username`, `email`, `user_token`) AGAINST ('\"{$search}\"' IN BOOLEAN MODE)")
						->limit($num, $start)
						->order_by('id', 'DESC')
						->get('users');
			}
			else
			{
				$s1 = $this->db->select('*')
							->limit($num, $start)
							->order_by('id', 'DESC')
							->get('users');
			}
			$this->data['row'] = $s1->result_array();

			$url = base_url($this->data['page_path'])."/users/p/";
			$this->data['pagination'] = pagination($total_users,$num,$url);
		}

		$this->load->view("templates/admin_header",$this->data);
		$this->load->view("pages/admin/users",$this->data);
		$this->load->view("templates/admin_footer",$this->data);

	}

	public function online ()
	{
		$s_online = $this->cms_model->select('online');
		$this->data['online'] = $s_online;

		$this->data['title'] = 'Online visitors';

		$this->load->view("templates/admin_header",$this->data);
		$this->load->view("pages/admin/online",$this->data);
		$this->load->view("templates/admin_footer",$this->data);
	}

	public function u ($var='',$id='')
	{
		$id = intval($id);

		if ($var == '')
		{
			show_my_404();
		}
		else if ($var == "edit")
		{
			$this->data['title'] = "Edit My Profile";

			$w['id'] = $id;

			$sel = $this->cms_model->select('users',$w);

			if ($sel->num_rows() == 1)
			{
				$row = $sel->row_array();

				if ($row['user_status'] == 1)
				{
					$this->data['forb_msg'] = "Sorry, You can't edit admin data from here !";
				}
				else
				{
					$this->data['userInfo'] = $row;

					$sel = $this->cms_model->select('usersmeta',array('user_id'=>$row['id']));
					$r = $sel->result_array();

					foreach ($r as $k => $row)
					{
						$this->data['userInfo'][$row['user_option']] = $row['user_value'];
					}
				}
			}
			else
			{
				$this->data['forb_msg'] = "This user not found !";
			}
		}

		$this->load->view("templates/admin_header",$this->data);
		$this->load->view("pages/admin/u",$this->data);
		$this->load->view("templates/admin_footer",$this->data);
	}

	public function languages($action = NULL)
	{
		if ($action == NULL)
		{
			$pagename = "Languages";
			$page = "languages";

			$r = $this->cms_model->select('languages');
			$this->data['result'] = $r->result_array();

		}
		else if ($action == 'add')
		{
			$pagename = "Add language";
			$page = 'add_lang';

			if ($this->input->post('add'))
			{
				$name = ucfirst($this->input->post('name', true));
				$symbol = $this->input->post('symbol', true);
				$direction = intval($this->input->post('direction', true));

				if ($name == '' or $symbol == '')
				{
					$err = 'Please fill all the fields.';
				}
				else if (!preg_match("/^([a-zA-Z0-9_.\-]+)$/", $name))
				{
					$err = 'Oops, the language name is invalid, it\'s should be consists of these (a-z, A-Z, 0-9, -, _) characters';
				}
				else if (!preg_match("/^([a-zA-Z0-9_\-.]+)$/", $symbol))
				{
					$err = 'Oops, the language symbol is invalid, it\'s should be consists of these (a-z, A-Z, 0-9, -, _) characters';
				}
				else
				{
					$w = "name='{$name}' OR symbol='{$symbol}'";
					$s = $this->cms_model->select('languages', $w);

					if ($s->num_rows() > 0)
					{
						$err = 'Oops, this language is already used, please try another language.';
					}
					else
					{
						$langData['name'] = $name;
						$langData['symbol'] = $symbol;
						$langData['isRTL'] = $direction;

						$save = $this->cms_model->insert('languages', $langData);

						$languageFolder = str_ireplace('\\', '/', APPPATH."language/");
						mkdir($languageFolder.$name);

						if ($save && copyFolder($languageFolder.'english', $languageFolder.$name, true))
						{
							header('location: '.base_url($this->data['page_path'].'/languages'));
							exit();
						}
						else
						{
							$err = 'Oops, Something wrong, please try again.';
						}
					}
				}
			}
		}
		else if ($action == 'edit')
		{
			$pagename = 'Edit language';
			$page = 'edit_lang';

			if ($this->input->post('edit'))
			{
				$symbol = $this->input->post('symbol', true);
				$direction = intval($this->input->post('direction', true));
				$status = intval($this->input->post('status', true));

				if ($symbol == '')
				{
					$err = 'Please fill all the fields.';
				}
				else if (!preg_match("/^([a-zA-Z0-9_\-.]+)$/", $symbol))
				{
					$err = 'Oops, the language symbol is invalid, it\'s should be consists of these (a-z, A-Z, 0-9, -, _) characters';
				}
				else
				{
					$w = "id=".intval($this->uri->segment(4));
					$s = $this->cms_model->select('languages', $w);
					$r = $s->row_array();

					$s2 = $this->cms_model->select('languages', ['symbol' => $symbol]);
					$s3 = $this->cms_model->select('languages', ['active' => 1]);


					if ($r['symbol'] != $symbol && $s2->num_rows() > 0)
					{
						$err = 'Oops, this language symbol is already used, please try to use another symbol.';
					}
					else if ($s3->num_rows() == 1 && $status == 0 && $r['active'] == 1)
					{
						$err = 'Oops, you can\'t disactivate the all languages from the website, you should at least to keep one language active.';
					}
					else
					{
						$langData['symbol'] = $symbol;
						$langData['isRTL'] = $direction;
						$langData['active'] = $status;
						$save = $this->cms_model->update('languages', $langData, ['id' => $r['id']]);

						if ($save)
						{
							header('location: '.base_url($this->data['page_path'].'/languages'));
							exit();
						}
						else
						{
							$err = 'Oops, Something wrong, please try again.';
						}
					}
				}
			}

			$s = $this->cms_model->select('languages', ['id' => intval($this->uri->segment(4))]);

			if ($s->num_rows() == 0)
			{
				header('location: '.base_url($this->data['page_path'].'/languages'));
			}
			else
			{
				$this->data['result'] = $s->row_array();
			}
		}

		if (isset($err) && $err != '')
		{
			$this->data['msg'] = "<div class='alert alert-warning'><i class='fa fa-lg fa-info-circle'></i> ".$err."</div>";
		}
		else if (isset($ok) && $ok != '')
		{
			$this->data['msg'] = "<div class='alert alert-success'><i class='fa fa-lg fa-check'></i> ".$ok."</div>";
		}

		$this->data['title'] = $pagename;

		$this->load->view("templates/admin_header",$this->data);
		$this->load->view("pages/admin/$page",$this->data);
		$this->load->view("templates/admin_footer",$this->data);
	}

	public function pages ($action="",$var="")
	{
		if ($action == '')
		{
			$pagename = 'Manage Pages';
			$page = 'pages_list';

			$select = $this->cms_model->select('pages');

			$this->data['pages'] = $select->result_array();

			$pageLangData = [];
			foreach ($this->data['pages'] as $row)
			{
				if ($row['lang_id'] == 0)
				{
					$pageLangData[] = 'All languages';
					continue;
				}

				$tmp_s = $this->cms_model->select('languages', ['id' => $row['lang_id']]);
				$pageLangData[] = $tmp_s->row_array()['name'];
				$tmp_s->free_result();
			}

			$this->data['pageLangData'] = $pageLangData;

			$select->free_result();
		}
		else if ($action == 'add')
		{
			$pagename = 'Add pages';
			$page = 'add_page';

			if ($this->input->post('add',TRUE))
			{
				$title 		= trim(strip_tags($this->input->post('title',TRUE)));
				$slug		= trim(strip_tags($this->input->post('slug',TRUE)));
				$lang_id	= intval($this->input->post('lang-id',TRUE));
				$keywords	= trim(strip_tags($this->input->post('keywords',TRUE)));
				$desc		= trim(strip_tags($this->input->post('desc',TRUE)));
				$published	= intval($this->input->post('published',TRUE));
				$header 	= intval($this->input->post('header',TRUE));
				$footer 	= intval($this->input->post('footer',TRUE));
				$content	= trim($this->input->post('content',TRUE));

				if ($title == '' or $slug == '')
				{
					$err = "Please add a <b>title</b> and a <b>slug</b> of a page.";
				}
				else if (!preg_match("/^([a-zA-Z0-9_-]+)$/",$slug))
				{
					$err = "the <b>slug</b> is not correct, it has a forbidden characters";
				}
				else
				{
					$where['slug']	= $slug;
					$where['lang_id'] = $lang_id;
					$s = $this->cms_model->select('pages',$where);

					if ($s->num_rows() == 1)
					{
						$err = "Oops, this <b>slug</b> is already used, please try another one.";
					}
					else
					{
						$d['title'] 		= $title;
						$d['slug'] 			= $slug;
						$d['lang_id'] 		= $lang_id;
						$d['keywords']		= $keywords;
						$d['description']	= $desc;
						$d['published'] 	= $published;
						$d['show_header']	= $header;
						$d['show_footer']	= $footer;
						$d['content'] 		= $content;
						$d['created']		= time();
						$d['modified']		= time();

						$insert = $this->cms_model->insert('pages',$d);

						if ($insert)
						{
							header('location: '.base_url($this->data['page_path'].'/pages'));
							exit();
						}
					}
				}

			}
		}
		else if ($action == 'edit')
		{
			$pagename = "Edit page";
			$page = "edit_pages";

			$id = intval($var);

			$w['id'] = $id;
			$s = $this->cms_model->select('pages',$w);

			if ($s->num_rows() == 1)
			{
				$this->data['pagedata'] = $s->row_array();
			}
			else
			{
				$err = "Page not Found!";
			}
		}

		if (isset($err) && $err != '')
		{
			$this->data['msg'] = "<div class='alert alert-warning'><i class='fa fa-lg fa-info-circle'></i> ".$err."</div>";
		}
		else if (isset($ok) && $ok != '')
		{
			$this->data['msg'] = "<div class='alert alert-success'><i class='fa fa-lg fa-check'></i> ".$ok."</div>";
		}

		$this->data['title'] = $pagename;

		$this->load->view("templates/admin_header",$this->data);
		$this->load->view("pages/admin/$page",$this->data);
		$this->load->view("templates/admin_footer",$this->data);
	}

	public function demo ($id='')
	{
		$id = intval($id);

		$w['id'] = $id;
		$sel = $this->cms_model->select('pages',$w);

		if ($sel->num_rows() == 1)
		{
			$row = $sel->row_array();
			$this->data['pagedata'] = $row;

			$this->data['title'] = $row['title'];
			$content = $this->data['pagedata']['content'];
			$this->data['page_content'] = do_filter('page_content', $content);

			$this->load->view("templates/header",$this->data);
			$this->load->view("pages/admin/page_demo",$this->data);
			$this->load->view("templates/footer",$this->data);
		}
		else
		{
			show_my_404();
		}
	}


	public function ajax ()
	{

		/*========================= Edit config (settings) of the website ===========================*/

		if ($this->input->post('tab'))
		{
			if (is_demo())
			{
				$ok = "Oops, This Action is not allowed on the Demo!";
			}
			else
			{
				$a =  array();

				if ($this->input->post('tab') == 1)
				{
					$a['show_logo'] 			= intval($this->input->post('show_logo',TRUE));
					$a['sitename'] 				= trim(strip_tags($this->input->post('site_name',TRUE)));
					$a['keywords'] 				= trim(strip_tags($this->input->post('keywords',TRUE)));
					$a['description'] 			= trim(strip_tags($this->input->post('desc',TRUE)));
					$a['default_language'] 			= trim(intval($this->input->post('default_lang',TRUE)));
					$a['siteemail'] 			= trim(strip_tags($this->input->post('support-email',TRUE)));
					$a['siteclose'] 			= trim(intval($this->input->post('status_site',TRUE)));
					$a['shutdown_msg'] 			= $this->input->post('msg_closed_site',TRUE);
					$a['tracking_code'] 		= $this->input->post('analytics_code',FALSE);
					$a['go_head_code'] 			= $this->input->post('go_head_code',FALSE);
					$a['default_timezone'] 		= trim(strip_tags($this->input->post('default_timezone',TRUE)));
					$a['time_format'] 			= strip_tags($this->input->post('time_format',TRUE));
					$a['currency'] 				= strip_tags($this->input->post('currency',TRUE));

				}
				else if ($this->input->post('tab') == 2)
				{
					$a['registration_status'] 	= intval($this->input->post('registration_status',TRUE));
					$a['shutdown_msg_register'] = strip_tags($this->input->post('shutdown_msg_register',TRUE));
					$a['user_delete_account'] 	= intval($this->input->post('account_status',TRUE));
					$a['notes_delete_account'] 	= trim($this->input->post('notes_delete_account',TRUE));
					$a['registration_bonus'] 	= (float)($this->input->post('registration_bonus',TRUE));
				}
				else if ($this->input->post('tab') == 3)
				{
					$a['ads_status_on_accounts'] = abs(intval($this->input->post('ads_status_on_accounts',TRUE)));
					$a['ads_status'] 			= abs(intval($this->input->post('ads_status',TRUE)));
					$a['admin_pub'] 			= strip_tags($this->input->post('pub',TRUE));
					$a['admin_channel'] 		= trim(intval($this->input->post('channel',TRUE)));
					$a['countdown'] 			= trim(abs(intval($this->input->post('countdown',TRUE))));
					$a['just_show_admin_ads'] 	= abs(intval($this->input->post('just_show_admin_ads',TRUE)));
					$a['just_show_users_ads'] 	= abs(intval($this->input->post('just_show_users_ads',TRUE)));
				}
				else if ($this->input->post('tab') == 4)
				{
					$a['cookie_expire'] 		= (intval($this->input->post('expir_time',TRUE)) < 1)? 1*3600*24 : intval($this->input->post('expir_time',TRUE))*3600*24 ;
					$a['cookie_name'] 			= (preg_match("/^([a-zA-Z0-9_-])+$/",$this->input->post('cookie_name',TRUE)))? mb_substr($this->input->post('cookie_name',TRUE),0,50,'UTF-8') : "ABC" ;
					$a['restoration_time_account'] = (intval($this->input->post('rest_time',TRUE)) < 1)? 1 : intval($this->input->post('rest_time',TRUE)) ;
					$a['secret_key'] 			= trim(strip_tags($this->input->post('secret_key',TRUE)));
					$a['public_key'] 			= trim(strip_tags($this->input->post('public_key',TRUE)));
					$a['recaptcha_status'] 		= intval($this->input->post('recaptcha_status',TRUE));
					$a['ip_max_visits'] 		= intval($this->input->post('ip_max_visits',TRUE));
					$a['bad_urls'] 				= trim(strip_tags($this->input->post('bad_urls',TRUE)));

				}
				else if ($this->input->post('tab') == 5)
				{
					$a['email_method'] 		= trim(strip_tags($this->input->post('email_method',TRUE)));
					$a['email_from'] 		= trim(strip_tags($this->input->post('email_from',TRUE)));
					$a['SMTP_Host'] 		= trim(strip_tags($this->input->post('SMTP_Host',TRUE)));
					$a['SMTP_Port'] 		= trim(strip_tags($this->input->post('SMTP_Port',TRUE)));
					$a['SMTP_User'] 		= trim(strip_tags($this->input->post('SMTP_User',TRUE)));
					$a['SMTP_Pass'] 		= trim(strip_tags($this->input->post('SMTP_Pass',TRUE)));
					$a['mail_encription'] 	= trim(strip_tags($this->input->post('mail_encription',TRUE)));
					$a['allow_SSL_Insecure_mode'] 	= intval($this->input->post('allow_SSL_Insecure_mode',TRUE));
				}
				else if ($this->input->post('tab') == 6)
				{
					$a['social_media_facebook'] 	= trim(strip_tags($this->input->post('social_media_facebook',TRUE)));
					$a['social_media_twitter'] 		= trim(strip_tags($this->input->post('social_media_twitter',TRUE)));
					$a['social_media_youtube'] 		= trim(strip_tags($this->input->post('social_media_youtube',TRUE)));
					$a['social_media_github'] 		= trim(strip_tags($this->input->post('social_media_github',TRUE)));
					$a['social_media_linkedin'] 	= trim(strip_tags($this->input->post('social_media_linkedin',TRUE)));
					$a['social_media_reddit'] 		= trim(strip_tags($this->input->post('social_media_reddit',TRUE)));
					$a['social_media_pinterest'] 	= trim(strip_tags($this->input->post('social_media_pinterest',TRUE)));
					$a['social_media_tumblr'] 		= trim(strip_tags($this->input->post('social_media_tumblr',TRUE)));
					$a['social_media_instagram'] 		= trim(strip_tags($this->input->post('social_media_instagram',TRUE)));
				}
				else if ($this->input->post('tab') == 10)
				{
					$a['showFakeNumbers'] 		= trim(abs(intval($this->input->post('showFakeNumbers',TRUE))));
					$a['fakeViews'] 			= trim(abs(intval($this->input->post('fakeViews',TRUE))));
					$a['fakeUsers'] 			= trim(abs(intval($this->input->post('fakeUsers',TRUE))));
					$a['fakeLinks'] 			= trim(abs(intval($this->input->post('fakeLinks',TRUE))));
				}



				$e = array();
				foreach ($a as $k => $v)
				{
					$set['option_name'] = $k;
					$set['option_value'] = $v;

					$where = array(
							'option_name' => $k
						);

					$up = $this->cms_model->update('settings',$set,$where);

					if ($up)
					{
						array_push($e,1);
					}
					else
					{
						array_push($e,0);
					}
				}


				if (!in_array(0,$e))
				{
					$ok = 'Saved successfully.';
				}
				else
				{
					$err = 'Error update !';
				}

			}
		} // end post submit

		/*=================== show messages ===================*/

		if ($this->input->post('uploadImg'))
		{
			if ($this->input->post('type') == 'icon')
			{
				$file_name = "favicon.png";
				$addType = "|ico";
				$input_name = "icon";
				$height = 72;
				$width = 72;
			}
			else
			{
				$file_name = "logo.png";
				$addType = "";
				$input_name = "logo";
				$height = 100;
				$width = 0;
			}

	        $config['upload_path']          = './assets/img/';
	        $config['allowed_types']        = 'gif|jpg|png'.$addType;
	        $config['max_size']             = 1024*1; // 1 MB
	        $config['max_width']            = 1024;
	        $config['max_height']           = 1024;
	        $config['file_name']			= $file_name;
	        $config['overwrite'] 			= TRUE;

	        $this->load->library('upload',$config);

			if (!$this->upload->do_upload($input_name))
			{
				$err = $this->upload->display_errors();
			}
			else
			{
				$img_data = $this->upload->data();

			    $conf['image_library'] 	= 'gd2';
			    $conf['source_image'] 	= './assets/img/'.$img_data['file_name'];
			    $conf['create_thumb'] 	= FALSE;
			    $conf['maintain_ratio'] = TRUE;
			    $conf['height']   		= $height; // <==
			    $conf['width']     		= $width; // auto <==
			    $conf['quality']		= 100;

			    $this->load->library('image_lib',$conf);

			    if (!$this->image_lib->resize())
			    {
			    	$err = $this->image_lib->display_errors();
			    }
			    else
			    {
			    	$ok = "The image has been uploaded successfully.";
			    }
			}
		}

		/*======================== delete announcement. ==========================*/

		if ($this->input->post('delete_ann'))
		{
			if (is_demo())
				die(json_encode([
					'deleted' => false,
					'message' => 'Oops, This Action is not allowed on the Demo!'
				]));

			header('Content-Type: application/json');

			$ann_id = intval($this->input->post('ann_id'));
			$delete = $this->db->delete('announcements', [
				'id' => $ann_id
			]);

			if ($delete)
			{
				die(json_encode([
					'deleted' => true,
					'message' => 'Deleted Successfully.'
				]));
			}

			die(json_encode([
				'deleted' => false,
				'message' => 'Something went wrong!'
			]));
		}

		/*======================== Edit user data at cpanel ==========================*/

		if ($this->input->post('edit-profile'))
		{
			if (is_demo())
			{
				$ok = "Oops, This Action is not allowed on the Demo!";
			}
			else
			{
				$userId = abs(intval($this->input->post('user_id',TRUE)));

				$where['id'] = $userId;
				$s = $this->cms_model->select('users',$where);

				if ($s->num_rows() == 1)
				{
					$row = $s->row_array();
					$old_email = $row['email'];
				}
				else
				{
					$err = "Oops, The user token is not correct!";
				}

				$s->free_result();

		        $username   = trim(strip_tags($this->input->post('username',TRUE)));
		        $email 		= trim(strip_tags($this->input->post('email',TRUE)));
		        $status 	= intval($this->input->post('status',TRUE));
		        $banned_msg = trim($this->input->post('banned_msg',TRUE));
		        $gender     = intval($this->input->post('gender',TRUE));
		        $country	= intval($this->input->post('country',TRUE));
		        $birth_day  = trim(strip_tags($this->input->post('birth-day',TRUE)));
		        $sec_ques   = trim(strip_tags($this->input->post('sec-que',TRUE)));
		        $ans_ques   = trim(strip_tags($this->input->post('ans-que',TRUE)));

		        $pub 		= strip_tags($this->input->post('pub',TRUE));
		        $channel 	= intval($this->input->post('channel',TRUE));
		        $earnings 	= (float)($this->input->post('earnings',TRUE));

		        if ($username == '')
		        {
		            $err = "Oops, insert the <b>username</b>";
		        }
		        else if (mb_strlen($username) < 4)
		        {
		            $err = "Oops, the <b>username</b> is too short.";
		        }
		        else if (mb_strlen($username) > 50)
		        {
		            $err = "Oops, the <b>username</b> is too long.";
		        }
				else if (!filter_var($email,FILTER_VALIDATE_EMAIL))
				{
					$err = "Oops, the <b>email</b> is not correct!";
				}
				else if ($this->cms_model->is_registered($email,array('email !='=>$old_email)))
				{
					$err = "Oops, this <b>email</b> is already used!";
				}
		        else
		        {
		            $user_id = $userId;

		            $set['username'] 		= $username;
		            $set['email']		 	= $email;
		            $set['gender']   		= $gender; // e.g. 1 = male | 2 = female
		           	$set['account_status']	= $status;
		           	$set['earnings']		= $earnings;

		            $w['id'] = $user_id;
		            $up = $this->cms_model->update('users',$set,$w);

		            $a['user_channel'] 	= $channel;
		            $a['country'] 		= $country;
		            $a['sec_ques'] 		= $sec_ques;
		            $a['ans_ques'] 		= $ans_ques;
		            $a['banned_msg'] 	= $banned_msg;

		            // delete all information from database by user_id
		            foreach ($a as $k => $v) {
		                $w = array();
		                $w['user_id'] = $user_id;
		                $w['user_option'] = $k;

		                $del = $this->cms_model->delete('usersmeta',$w);
		            }

		            // insert all information to database
		            $s = array();
		            foreach ($a as $k => $v)
		            {
		            	$d = array();
		                $d['user_id'] = $user_id;
		                $d['user_option'] = $k;
		                $d['user_value'] = $v;

		                $sel = $this->cms_model->insert('usersmeta',$d);
		                if ($sel)
		                {
		                    array_push($s,1);
		                }
		                else
		                {
		                    array_push($s,0);
		                }
		            }

		            if (in_array(0,$s))
		            {
		                $err = "Sorry, Something was wrong !";
		            }
		            else
		            {
		                $ok = "Saved successfully.";
		            }
		        }
			}

		} // end of edit profile

		/*========================= Delete users ===========================*/

		if ($this->input->post('deleteUser') == 1)
		{
			if (is_demo())
				die('Oops, This Action is not allowed on the Demo!');

			$id = intval($this->input->post('id',TRUE));

			$where['id'] = $id;
			$s = $this->cms_model->select('users',$where);

			if ($s->num_rows() == 1)
			{
				$row = $s->row_array();

				if ($row['user_status'] == 1)
				{
					echo "Oops, You Can't delete the Admin";
				}
				else
				{
					$w['id'] = $id;
					$d = $this->cms_model->delete('users',$w);

					$wr['user_id'] = $row['id'];
					$d2 = $this->cms_model->delete('usersmeta',$wr);

					if ($d && $d2)
					{
						echo "Deleted successfully :)";
					}
					else
					{
						echo "Oops, Something was wrong!";
					}
				}
			}
			else
			{
				echo "Oops, The user not found (ID=".$id.") !";
			}

			$s->free_result();

		} // end of function

		/*================== Delete profile image =================*/

		if ($this->input->post('delete_image'))
		{
			$token = $this->input->post('token',TRUE);

			if (delete_profile_img($token))
			{
				echo "Deleted successfully.";
			}
			else
			{
				echo "Something was wrong !";
			}
		}

		/*================== Edit data page =================*/

		if ($this->input->post('edit-page'))
		{
			if (is_demo())
			{
				$ok = "Oops, This Action is not allowed on the Demo!";
			}
			else
			{
				$title 		= trim(strip_tags($this->input->post('title',TRUE)));
				$slug		= trim(strip_tags($this->input->post('slug',TRUE)));
				$lang_id	= intval($this->input->post('lang-id',TRUE));
				$keywords 	= trim(strip_tags($this->input->post('keywords',TRUE)));
				$desc 		= trim(strip_tags($this->input->post('desc',TRUE)));
				$published 	= intval($this->input->post('published',TRUE));
				$header 	= intval($this->input->post('header',TRUE));
				$footer 	= intval($this->input->post('footer',TRUE));
				$content 	= trim($this->input->post('content',TRUE));
				$id 		= intval($this->input->post('id',TRUE));

				$where['id'] = $id;
				$s = $this->cms_model->select('pages',$where);

				if ($s->num_rows() == 1)
				{
					$row = $s->row_array();

					if ($row['uneditable'] == 1)
					{
						$slug = $row['slug'];
					}

					if ($title == '')
					{
						$err = "Please insert a <b>title</b> !";
					}
					if ($slug == '')
					{
						$err = "Please insert a <b>slug</b> !";
					}
					else if (!preg_match("/^([a-zA-Z0-9_-]+)$/",$slug))
					{
						$err = "the <b>slug</b> is not correct, it has a forbidden characters";
					}
					else
					{
						$wh['slug']	= $slug;
						$wh['lang_id'] = $lang_id;
						$s2 = $this->cms_model->select('pages',$wh);

						if ($row['lang_id'] != $lang_id && $s2->num_rows() > 0)
						{
							$err = "Oops, this <b>slug</b> is already used at this language that you choosed.";
						}
						else
						{
							$set['title'] 		= $title;
							$set['slug'] 		= $slug;
							$set['lang_id']		= $lang_id;
							$set['keywords'] 	= $keywords;
							$set['description'] = $desc;
							$set['published'] 	= $published;
							$set['show_header'] = $header;
							$set['show_footer'] = $footer;
							$set['content'] 	= $content;
							$set['modified']	= time();

							$w['id'] = $id;
							$update = $this->cms_model->update('pages',$set,$w);

							if ($update)
							{
								$ok = "Updated successfully.";
							}
							else
							{
								$err = "Something was wrong!";
							}
						}
					}
				}
			}
		}

		/*================== Delete page =================*/

		if ($this->input->post('deletePage'))
		{
			if (is_demo())
				die("Oops, This Action is not allowed on the Demo!");

			$id = intval($this->input->post('id',TRUE));

			$w['id'] = $id;
			$w['uneditable'] = 0;
			$del = $this->cms_model->delete('pages',$w);

			if ($del)
			{
				echo "Deleted successfully.";
			}
			else
			{
				echo "Oops, Something was wrong !";
			}
		}

		/*============= Delete save WithdrowRequest status ============*/

		if ($this->input->post('saveWithdrowRequestStatus'))
		{
			$id = intval($this->input->post('id', TRUE));
			$status = intval($this->input->post('status_id', TRUE));

			$updated = $this->db->set(['status' => $status])->where(['id' => $id])->update('withdraw_reqs');

			if ($updated)
			{
				echo "Status updated successfully.";
			}
			else
			{
				echo "Oops, Something was wrong !";
			}
		}

		/*================== Delete withdrawal request =================*/

		if ($this->input->post('deleteWithdrowRequest'))
		{
			$id = intval($this->input->post('id', TRUE));
			$del = $this->db->delete('withdraw_reqs', ['id' => $id]);

			if ($del)
			{
				echo "Deleted successfully.";
			}
			else
			{
				echo "Oops, Something was wrong !";
			}
		}

		/*================== Delete withdrawal method =================*/

		if ($this->input->post('deleteWithdrawalMethod'))
		{
			if (is_demo())
				die('Oops, This Action is not allowed on the Demo!');

			$id = intval($this->input->post('id', TRUE));
			$del = $this->db->delete('withdrawal_methods', ['id' => $id]);

			if ($del)
			{
				echo "Deleted successfully.";
			}
			else
			{
				echo "Oops, Something was wrong !";
			}
		}

		/*================== edit link data ==============*/

		if ($this->input->post('link_id'))
		{
			$slug 		= trim(strip_tags($this->input->post('slug')));
			$new_slug 	= trim(strip_tags($this->input->post('new_slug')));
			$link_id 	= abs(intval($this->input->post('link_id')));
			$title 		= trim(strip_tags($this->input->post('title')));
			$org_url 	= trim(strip_tags($this->input->post('origin_url')));
			$status 	= trim(strip_tags($this->input->post('status')));
			$direct_redirection = intval($this->input->post('direct-redirection', true));
			$keywords 	= $this->input->post('keywords', true);
			$description= $this->input->post('description', true);


			$w_s['slug'] = $new_slug;
			$s = $this->cms_model->select('links', $w_s);

			if ($new_slug != $slug && $s->num_rows() > 0)
			{
				$err = "Oops, the <b>slug</b> is already used !";
			}
			else
			{
				$set['title'] 	= $title;
				$set['url'] 	= encode($org_url);
				$set['slug'] 	= $new_slug;
				$set['status'] 	= $status;
				$set['direct_redirection'] 	= $direct_redirection;
				$set['keywords'] 	= $keywords;
				$set['description'] = $description;

				$w['id'] = $link_id;

				$up = $this->cms_model->update('links', $set, $w);

				if ($up)
				{
					$ok = "Saved successfully.";
				}
				else
				{
					$err = "Oops, Something was wrong !";
				}
			}
		}

		/*================== delete links ==================*/

		if ($this->input->post('deleteLink') == 1)
		{
			if (is_demo())
				die('Oops, This Action is not allowed on the Demo!');

			$id = abs(intval($this->input->post('id')));

			$w['id'] = $id;
			$del = $this->cms_model->delete('links',$w);

			if ($del)
			{
				echo "Delete successfully.";
			}
			else
			{
				echo "Oops, Something was wrong !";
			}
		}

		/*================== delete language ==================*/

		if ($this->input->post('deleteLang') == 1)
		{
			$id = abs(intval($this->input->post('id')));

			$w['id'] = $id;
			$w['undeletable'] = 0;

			$s = $this->cms_model->select('languages',$w);
			$result = $s->row_array();


			$del = $this->cms_model->delete('languages',$w);

			if ($s->num_rows() && $del)
			{
				$path = APPPATH.'language/'.$result['name'];

				if (is_dir($path))
				{
					if (deleteFolder($path, true))
						echo "Deleted successfully.";
					else
						echo "Oops, Something is wrong !";
				}
				else
				{
					echo "Oops, Something is wrong !";
				}
			}
			else
			{
				echo "Oops, Something is wrong !";
			}
		}

		//=================== show messages ===================

		if (isset($err) && $err != '')
		{
			echo "<div class='alert alert-danger'>".$err."</div>";
		}
		else if (isset($ok) && $ok != '')
		{
			echo "<div class='alert alert-success'>".$ok."</div>";
		}

	} // end ajax function


	public function links ($action='',$page='')
	{
		if($action == "" || $action == 'p')
		{
			if ($this->input->get())
			{
				$search = trim(strip_tags($this->input->get('search',TRUE)));
				$this->data['search'] = $search;
				$cols = ['title', 'slug'];
				$imploded = '';

				if (version_compare(PHP_VERSION, '7.4', '>='))
				    $imploded = implode(',', $cols);
				else
				    $imploded = implode($cols, ',');
			}

			$links_per_page = 20;
			$page = intval($page);

			if (!isset($search))
			{
				$total_items = $this->db->select('COUNT(id) as total_links')
										->get('links')
										->first_row()
										->total_links;
			}
			else
			{
				$total_items = $this->db->select('COUNT(id) as total_links')
										->where("MATCH($imploded) AGAINST('$search' IN BOOLEAN MODE)", NULL, FALSE)
										->get('links')
										->first_row()
										->total_links;
			}

			$all_pages = ceil($total_items / $links_per_page);
			if ($page < 1 or $page > $all_pages)
				$page = 1;

			$start = ($page-1) * $links_per_page;


			if (!isset($search))
			{
				$links = $this->db->select('links.id, links.title, links.slug, links.domain, links.status, links.created, links.url, links.direct_redirection')
											->select_sum('stats.views', 'total_views')
											->select_sum('stats.earnings', 'total_earnings')
											->from('links')
											->join('stats', 'stats.link_id = links.id', 'left')
											->group_by('links.id')
											->order_by('links.created', 'DESC')
											->limit($links_per_page, $start)
											->get();
			}
			else
			{
				$links = $this->db->select('links.id, links.title, links.slug, links.domain, links.status, links.created, links.url, links.direct_redirection')
											->select_sum('stats.views', 'total_views')
											->select_sum('stats.earnings', 'total_earnings')
											->from('links')
											->join('stats', 'stats.link_id = links.id', 'left')
											->where("MATCH($imploded) AGAINST('$search' IN BOOLEAN MODE)", NULL, FALSE)
											->group_by('links.id')
											->order_by('links.created', 'DESC')
											->limit($links_per_page, $start)
											->get();
			}

			$this->data['links'] = $links;


			// ===========================
			$this->data['all_items'] = $total_items;
			$this->data['links_per_page'] = $links_per_page;
			$this->data['page'] = $page;
			$this->data['all_pages'] = $all_pages;


			$this->data['title'] = 'All links';

			$this->load->view("templates/admin_header",$this->data);
			$this->load->view("pages/admin/links",$this->data);
			$this->load->view("templates/admin_footer",$this->data);
		}
		else if ($action == "edit")
		{
			$slug = trim(strip_tags($page));

			$w['slug'] = $slug;
			$s = $this->cms_model->select('links',$w);
			$this->data['s'] = $s;

			$row = $s->row_array();

			$w_user['id'] = $row['user_id'];
			$s_user = $this->cms_model->select('users',$w_user);

			$this->data['user_info'] = $s_user;

			$this->data['title'] = 'Edit link';

			$this->load->view("templates/admin_header",$this->data);
			$this->load->view("pages/admin/edit_link",$this->data);
			$this->load->view("templates/admin_footer",$this->data);

			$s->free_result();
			$s_user->free_result();
		}
	}

	public function payout_rates($action='')
	{
		if ($this->input->post())
		{
			$posted_countries = $this->input->post('countries', true);
			$world_wide = (float)$this->input->post('world_wide', true);

			$this->db->set([
				'option_value' => $world_wide,
			])->where([
				'option_name' => 'world_wide',
			])->update('settings');

			foreach($posted_countries as $country_id => $new_price)
			{
				$this->db->set(['price' => $new_price]);
				$this->db->where(['country_id' => $country_id]);
				$this->db->update('publisher_rates');
			}

			set_message('Saved successfully.', 'success');
			redirect($this->data['page_path'].'/payout_rates', 'refresh');
		}

		$this->data['title'] = 'Payout Rates';

		$countries = $this->db->select('*')->from('countries')->join('publisher_rates', 'countries.id = publisher_rates.country_id')->get()->result();
		$this->data['countries'] = $countries;
		$this->data['world_wide'] = (float)get_config_item('world_wide');

		$this->load->view("templates/admin_header",$this->data);
		$this->load->view("pages/admin/payout_rates",$this->data);
		$this->load->view("templates/admin_footer",$this->data);
	}


	public function withdrawal_methods($action='', $payment_method_id=0)
	{
		$this->data['payment_methods'] = [];
		$view_page = 'withdrawal_methods';
		$payment_method_id = intval($payment_method_id);

		if ($action == '')
		{
			$this->data['title'] = 'Withdrawal Methods';
			$this->data['withdrawal_methods'] = $this->db->select('*')->from('withdrawal_methods')->get()->result_object();
		}
		else if ($action == 'add')
		{
			$this->data['title'] = 'Add Withdrawal Method';
			$view_page = 'add_withdrawal_method';

			if ($this->input->post('add'))
			{
				$name = $this->input->post('name', true);
				$min_amount = $this->input->post('min_amount', true);
				$status = intval($this->input->post('status', true));
				$desc = $this->input->post('desc', true);

				$this->db->set([
					'name' => $name,
					'min_amount' => $min_amount,
					'status' => $status,
					'description' => $desc,
				])->insert('withdrawal_methods');

				set_message('Added successfully.', 'success');
				redirect("{$this->data['page_path']}/withdrawal_methods", 'refresh');
			}
		}
		else if ($action == 'edit')
		{
			$view_page = 'edit_withdrawal_method';
			$this->data['title'] = 'Edit Withdrawal Method';
			$withdrawal_methods = $this->db->select('*')->where(['id' => $payment_method_id])->get('withdrawal_methods');


			if ($this->input->post())
			{
				$name = $this->input->post('name', true);
				$min_amount = $this->input->post('min_amount', true);
				$status = intval($this->input->post('status', true));
				$desc = $this->input->post('desc', true);

				$this->db->set([
					'name' => $name,
					'min_amount' => $min_amount,
					'status' => $status,
					'description' => $desc,
				])->where([
					'id' => $payment_method_id
				])->update('withdrawal_methods');

				set_message('Updated successfully.', 'success');
				redirect("{$this->data['page_path']}/withdrawal_methods", 'refresh');
			}

			if ($withdrawal_methods->num_rows())
			{
				$this->data['method'] = $withdrawal_methods->result_object()[0];
			}
			else
			{
				set_message('Payment method not found.', 'warning');
				redirect("{$this->data['page_path']}/withdrawal_methods", 'refresh');
			}
		}

		$this->load->view("templates/admin_header",$this->data);
		$this->load->view("pages/admin/{$view_page}",$this->data);
		$this->load->view("templates/admin_footer",$this->data);
	}

	public function withdrawal_reqs($action='', $withdraw_reqs=0)
	{
		$view_page = 'withdrawal_reqs';
		$withdraw_reqs = intval($withdraw_reqs);

		$this->data['title'] = 'Withdrawal Requests';

		$q = $this->input->get('q', true);
		$status = $this->input->get('status', true);
		$method = $this->input->get('method', true);

		if ($this->input->get())
		{
			$this->data['q'] = $q;
			$this->data['status_id'] = $status;
			$this->data['method_id'] = $method;
			$where = [];
			$q_where = [];

			if ($status != 'all')
				$where['withdraw_reqs.status'] = $status;

			if ($method != 'all')
				$where['withdrawal_methods.id'] = $method;
			if ($q != ''){
				$q_where = "( withdraw_reqs.id = '$q' OR users.email = '$q' OR withdraw_reqs.withdrawal_account = '$q' )" ;
			}


			$this->data['result'] = $this->db->select('*, withdraw_reqs.amount as withdraw_amount, withdraw_reqs.status AS status, withdrawal_methods.status AS withdrawal_method_status, withdraw_reqs.id AS id, withdraw_reqs.withdrawal_account as withdrawal_account')
								->from('withdraw_reqs')
								->join('users', 'users.id = withdraw_reqs.user_id')
								->join('withdrawal_methods', 'withdraw_reqs.withdrawal_method_id = withdrawal_methods.id')
								->where($where)
								->where($q_where)
								->get()
								->result_object();
		}
		else
		{

			$this->data['result'] = $this->db->select('*, withdraw_reqs.amount as withdraw_amount, withdraw_reqs.status AS status, withdrawal_methods.status AS withdrawal_method_status, withdraw_reqs.id AS id, withdraw_reqs.withdrawal_account as withdrawal_account')
								->from('withdraw_reqs')
								->join('users', 'users.id = withdraw_reqs.user_id')
								->join('withdrawal_methods', 'withdraw_reqs.withdrawal_method_id = withdrawal_methods.id')
								->get()
								->result_object();
		}

		$this->data['methods'] = $this->db->select('*')->get('withdrawal_methods')->result_object();


		$this->load->view("templates/admin_header",$this->data);
		$this->load->view("pages/admin/{$view_page}",$this->data);
		$this->load->view("templates/admin_footer",$this->data);
	}

	public function announcements($action = '', $ann_id = 0)
	{
		if ($action === 'add')
		{
			if ($this->input->post('add'))
			{
				if (is_demo())
				{
					set_message('Oops, This Action is not allowed on the Demo!', 'success');
					redirect("{$this->data['page_path']}/announcements", 'refresh');
				}
				else
				{
					$message = $this->input->post('content', true);
					$status = intval($this->input->post('status', true));
					$availability = intval($this->input->post('availability', true));
					$color = $this->input->post('color', true);
					$background = $this->input->post('background', true);

					$ann = $this->db->insert('announcements', [
						'message' => $message,
						'status' => $status,
						'availability' => $availability,
						'color' => $color,
						'background' => $background,
					]);

					if ($ann)
					{
						set_message('Added successfully.', 'success');
						redirect("{$this->data['page_path']}/announcements", 'refresh');
					}
				}
			}

			$this->data['title'] = 'Add Announcement';

			$this->load->view("templates/admin_header", $this->data);
			$this->load->view("pages/admin/add_announcement", $this->data);
			$this->load->view("templates/admin_footer", $this->data);
		}
		else if ($action === 'edit')
		{

			$ann = $this->db->where('id', intval($ann_id))->get('announcements')->first_row();

			if (!isset($ann->id))
			{
				return redirect("{$this->data['page_path']}/announcements/", 'refresh');
			}

			if ($this->input->post('edit'))
			{
				if (is_demo())
				{
					set_message('Oops, This Action is not allowed on the Demo!', 'success');
					redirect("{$this->data['page_path']}/announcements", 'refresh');
				}
				else
				{
					$message = $this->input->post('content', true);
					$status = intval($this->input->post('status', true));
					$availability = intval($this->input->post('availability', true));
					$color = $this->input->post('color', true);
					$background = $this->input->post('background', true);

					$ann = $this->db->where('id', intval($ann_id))
									->update('announcements', [
										'message' => $message,
										'status' => $status,
										'availability' => $availability,
										'color' => $color,
										'background' => $background,
									]);

					if ($ann)
					{
						set_message('Updated successfully.', 'success');
						redirect("{$this->data['page_path']}/announcements", 'refresh');
					}
				}
			}


			$this->data['title'] = 'Edit Announcement';

			$this->data['ann'] = $ann;

			$this->load->view("templates/admin_header", $this->data);
			$this->load->view("pages/admin/edit_announcement", $this->data);
			$this->load->view("templates/admin_footer", $this->data);
		}
		else
		{
			$this->data['title'] = 'Announcements';
			$announcements = $this->db->get('announcements')->result_object();

			$this->data['announcements'] = $announcements;

			$this->load->view("templates/admin_header", $this->data);
			$this->load->view("pages/admin/announcements", $this->data);
			$this->load->view("templates/admin_footer", $this->data);
		}
	}

	public function custom_domains($action='', $id=null)
	{
		// domain protection
		if ($this->input->get('change', true) == 'domain-protection')
		{
			$domain_protection = intval(get_config_item('main_domain_protection'));

			if (is_demo())
			{
				$result = ["enabled" => false, "message" => 'Oops, This Action is not allowed on the Demo!', "status" => "warning"];
				return die(json_encode($result));
			}

			if ($domain_protection == 0)
			{
				// Enabled
				if ($this->db->where('status', '1')->get('domains')->num_rows() <= 0)
				{
					$result = ["enabled" => false, "message" => "Can't be enabled, please add a Custom Domain first.", "status" => "info"];
					return die(json_encode($result));
				}

				set_config_item('main_domain_protection', 1);
				$result = ["enabled" => true, "message" => 'Enabled Successfully.', "status" => "success"];
				return die(json_encode($result));
			}
			else
			{
				// Disabled
				set_config_item('main_domain_protection', 0);
				$result = ["enabled" => false, "message" => 'Disabled Successfully.', "status" => "success"];
				return die(json_encode($result));
			}
		}

		if ($action == 'add')
		{
			if ($this->input->post('add'))
			{
				if (is_demo())
				{
					set_message('Oops, This Action is not allowed on the Demo!', 'success');
					return redirect("{$this->data['page_path']}/custom_domains", 'refresh');
				}
				else
				{
					$domain = $this->input->post("domain-name", true);
					$status = intval($this->input->post("status", true));

					if (!is_domain($domain))
					{
						set_message('Invalid domain name!', 'warning');
						redirect("{$this->data['page_path']}/custom_domains/add", "refresh");
					}
					else if ($this->db->where('domain_name', $domain)->get('domains')->num_rows())
					{
						set_message('This domain is already exist!');
						redirect("{$this->data['page_path']}/custom_domains/add", "refresh");
					}
					else
					{
						$ins = $this->db->insert('domains', [
							'domain_name' => $domain,
							'status' => $status
						]);

						if ($ins)
						{
							set_message('Added successfully', 'success');
							redirect("{$this->data['page_path']}/custom_domains", "refresh");
						}
					}
				}
			}

			$this->data['title'] = 'Add Custom Domain';

			$this->load->view("templates/admin_header", $this->data);
			$this->load->view("pages/admin/add_custom_domain", $this->data);
			$this->load->view("templates/admin_footer", $this->data);
		}
		else if ($action == 'edit')
		{
			$current_domain = $this->db->where('id', intval($id))->get('domains')->first_row();

			if (!$current_domain)
			{
				return redirect("{$this->data['page_path']}/custom_domains", 'refresh');
			}

			if ($this->input->post('edit'))
			{

				if (is_demo())
				{
					set_message('Oops, This Action is not allowed on the Demo!', 'success');
					redirect("{$this->data['page_path']}/custom_domains", 'refresh');
				}
				else
				{
					$domain = $this->input->post("domain-name", true);
					$status = intval($this->input->post("status", true));

					if (!is_domain($domain))
					{
						set_message('Invalid domain name!', 'warning');
						redirect("{$this->data['page_path']}/custom_domains/edit/{$current_domain->id}", "refresh");
					}
					else if ($domain != $current_domain->domain_name && $this->db->where('domain_name', $domain)->get('domains')->num_rows())
					{
						set_message('This domain is already exist!');
						redirect("{$this->data['page_path']}/custom_domains/edit/{$current_domain->id}", "refresh");
					}
					else
					{
						$ins = $this->db->where('id', $current_domain->id)->update('domains', [
							'domain_name' => $domain,
							'status' => $status
						]);

						if ($ins)
						{
							set_message('Updated successfully', 'success');
							redirect("{$this->data['page_path']}/custom_domains", 'refresh');
						}
					}

				}
			}

			$this->data['title'] = 'Add Custom Domain';
			$this->data['domain'] = $current_domain;

			$this->load->view("templates/admin_header", $this->data);
			$this->load->view("pages/admin/edit_custom_domain", $this->data);
			$this->load->view("templates/admin_footer", $this->data);
		}
		else
		{
			$this->data['domains'] = $this->db->get('domains')->result();

			$this->data['title'] = 'Custom Domains';

			$this->load->view("templates/admin_header", $this->data);
			$this->load->view("pages/admin/custom_domains", $this->data);
			$this->load->view("templates/admin_footer", $this->data);
		}
	}

	public function ads($action=null, $id=null)
	{
		if ($action == 'delete')
		{
			$id = intval($id);
			$delete = $this->db->where('id', $id)->delete('ads');
			if ($delete)
			{
				die(json_encode([
					'deleted' => true,
					'message'=> 'Deleted successfully.'
				]));
			}
			else
			{
				die(json_encode([
					'deleted' => false,
					'message'=> 'Something went wrong!'
				]));
			}
		}
		else if ($action == 'add')
		{
			$code = $this->input->post('code', false);
			$placement = intval($this->input->post('placement', true));
			$status = intval($this->input->post('status', true));

			if ($this->input->post('add'))
			{
				if (is_demo())
				{
					set_message('Oops, This Action is not allowed on the Demo!', 'success');
					return redirect("{$this->data['page_path']}/ads", 'refresh');
				}

				$inserted = $this->db->insert('ads', [
					'code' 		=> $code,
					'placement' => $placement,
					'status' 	=> $status
				]);

				if ($inserted)
				{
					set_message('Added successfully');
					return redirect("{$this->data['page_path']}/ads", 'refresh');
				}
				else
				{
					set_message('Oops! Something went wrong!');
					return redirect("{$this->data['page_path']}/ads/add", 'refresh');
				}
			}

			$this->data['title'] = 'New Ad Placement';

			$this->load->view("templates/admin_header", $this->data);
			$this->load->view("pages/admin/add_ad", $this->data);
			$this->load->view("templates/admin_footer", $this->data);
		}
		else if ($action == 'edit')
		{
			$id = intval($id);
			$current_ad = $this->db->where('id', $id)->get('ads')->first_row();

			if ($this->input->post('edit'))
			{
				$code = $this->input->post('code', false);
				$placement = intval($this->input->post('placement', true));
				$status = intval($this->input->post('status', true));

				if (is_demo())
				{
					set_message('Oops, This Action is not allowed on the Demo!', 'success');
					return redirect("{$this->data['page_path']}/ads", 'refresh');
				}

				$updated = $this->db->where('id', $current_ad->id)->update('ads', [
					'code' 		=> $code,
					'placement' => $placement,
					'status' 	=> $status
				]);

				if ($updated)
				{
					set_message('Updated successfully');
					return redirect("{$this->data['page_path']}/ads", 'refresh');
				}
				else
				{
					set_message('Oops! Something went wrong!');
					return redirect("{$this->data['page_path']}/ads/edit", 'refresh');
				}
			}

			$this->data['title'] = 'Edit Ad Placement';
			$this->data['ad'] = $current_ad;

			$this->load->view("templates/admin_header", $this->data);
			$this->load->view("pages/admin/edit_ad", $this->data);
			$this->load->view("templates/admin_footer", $this->data);
		}
		else
		{
			// Get all Ads
			$ads = $this->db->order_by('id', 'DESC')->get('ads')->result();

			$this->data['title'] = 'Ads Placement';
			$this->data['ads'] = $ads;

			$this->load->view("templates/admin_header", $this->data);
			$this->load->view("pages/admin/ads", $this->data);
			$this->load->view("templates/admin_footer", $this->data);
		}
	}

	public function theme($action=null)
	{
		if ($action == 'save')
		{
			$theme_configs = json_decode(($this->input->raw_input_stream));

			foreach ($theme_configs as $name => $value)
			{
				$this->db->where('option_name', 'theme_'.$name)->update('settings', [
					'option_value' => $value
				]);
			}

			die(json_encode([
				'success' => true,
				'message' => 'Saved Successfully.'
			]));
		}

		$theme_configs = get_theme_configs();

		$this->data['title'] = 'Theme Customization';
		$this->data['theme_configs'] = $theme_configs;

		$this->load->view("templates/admin_header", $this->data);
		$this->load->view("pages/admin/theme", $this->data);
		$this->load->view("templates/admin_footer", $this->data);
	}

	public function system_info()
	{
		$this->data['title'] = "System Info";


		$this->load->view('templates/admin_header',$this->data);
		$this->load->view('pages/admin/system_info',$this->data);
		$this->load->view('templates/admin_footer',$this->data);
	}
}


?>
