<?php

declare(strict_types=1);

namespace ADLinker\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20221111202129 extends AbstractMigration
{
    public function getDescription(): string
    {
        $this->site_name      = trim(_addslashes(strip_tags(getenv('SITE_NAME'))));
        $this->support_email  = trim(strtolower(_addslashes(strip_tags(getenv('SITE_CONTACT_US_EMAIL')))));
        $this->sub_folder     = get_sub_folder();
        $this->time           = time();

        $this->admin_name     = trim(_addslashes(strip_tags(getenv('USER_USERNAME'))));
        $this->admin_email    = trim(strtolower(_addslashes(strip_tags(getenv('USER_EMAIL')))));
        $this->admin_pass     = trim(_addslashes(strip_tags(getenv('USER_PASSWORD'))));

        $this->db_prefix      = trim(strtolower(_addslashes(strip_tags(getenv('DB_PREFIX')))));
        $this->db_hostname    = trim(_addslashes(strip_tags(getenv('DB_HOSTNAME'))));
        $this->db_name        = trim(_addslashes(strip_tags(getenv('DB_NAME'))));
        $this->db_username    = trim(_addslashes(strip_tags(getenv('DB_USER'))));
        $this->db_password    = trim(_addslashes(strip_tags(getenv('DB_PASSWORD'))));

        return 'settings update';
    }

    public function up(Schema $schema): void
    {
        // Fixing contact form display (added by default).
        $this->addSql("UPDATE `{$this->db_prefix}pages` set content='{{CONTACT_FORM}}' WHERE slug='contact'");

        // Adding some settings.
        $this->addSql("INSERT INTO `{$this->db_prefix}settings` (option_name, option_value, autoload) VALUES ('main_domain', '', 'yes')");

        $this->addSql("INSERT INTO `{$this->db_prefix}settings` (option_name, option_value, autoload) VALUES ('main_domain_protection', '0', 'yes')");


        // Creating a domains table (custom domains)
        $sm = $this->connection->getSchemaManager();

        $ann = $schema->createTable($this->db_prefix.'domains');
        $ann->addColumn('id', 'bigint', [
            'autoincrement' => true
        ]);
        $ann->addColumn('domain_name', 'string', ['default' => null, 'notnull' => false]);
        $ann->addColumn('status', 'integer', ['default' => 0 ]);
        $ann->addColumn('created', 'datetime', ['default' => "CURRENT_TIMESTAMP"]);

        $ann->setPrimaryKey(['id']);
    }

    public function down(Schema $schema): void
    {
        $this->addSql("DELETE FROM `{$this->db_prefix}settings` WHERE option_name='main_domain'");
        $this->addSql("DELETE FROM `{$this->db_prefix}settings` WHERE option_name='main_domain_protection'");
        $this->addSql('DROP TABLE IF EXISTS '.$this->db_prefix.'domains');
    }
}
