<?php

declare(strict_types=1);

namespace ADLinker\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20221202123540 extends AbstractMigration
{
    public function getDescription(): string
    {
        $this->site_name      = trim(_addslashes(strip_tags(getenv('SITE_NAME'))));
        $this->support_email  = trim(strtolower(_addslashes(strip_tags(getenv('SITE_CONTACT_US_EMAIL')))));
        $this->sub_folder     = get_sub_folder();
        $this->time           = time();

        $this->admin_name     = trim(_addslashes(strip_tags(getenv('USER_USERNAME'))));
        $this->admin_email    = trim(strtolower(_addslashes(strip_tags(getenv('USER_EMAIL')))));
        $this->admin_pass     = trim(_addslashes(strip_tags(getenv('USER_PASSWORD'))));

        $this->db_prefix      = trim(strtolower(_addslashes(strip_tags(getenv('DB_PREFIX')))));
        $this->db_hostname    = trim(_addslashes(strip_tags(getenv('DB_HOSTNAME'))));
        $this->db_name        = trim(_addslashes(strip_tags(getenv('DB_NAME'))));
        $this->db_username    = trim(_addslashes(strip_tags(getenv('DB_USER'))));
        $this->db_password    = trim(_addslashes(strip_tags(getenv('DB_PASSWORD'))));

        return 'Ads Placement';
    }

    public function up(Schema $schema): void
    {
        // Creating a Ads Placement table.
        $sm = $this->connection->getSchemaManager();

        $ann = $schema->createTable($this->db_prefix.'ads');
        $ann->addColumn('id', 'bigint', [
            'autoincrement' => true
        ]);
        $ann->addColumn('code', 'text', ['default' => null, 'notnull' => false]);
        $ann->addColumn('placement', 'integer', ['default' => 0 ]);
        $ann->addColumn('status', 'integer', ['default' => 0 ]);
        $ann->addColumn('created', 'datetime', ['default' => "CURRENT_TIMESTAMP"]);

        $ann->setPrimaryKey(['id']);

    }

    public function down(Schema $schema): void
    {
        $this->addSql('DROP TABLE IF EXISTS '.$this->db_prefix.'ads');
    }
}
