<?php

declare(strict_types=1);

namespace ADLinker\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20221205122911 extends AbstractMigration
{
    public function getDescription(): string
    {
        $this->site_name      = trim(_addslashes(strip_tags(getenv('SITE_NAME'))));
        $this->support_email  = trim(strtolower(_addslashes(strip_tags(getenv('SITE_CONTACT_US_EMAIL')))));
        $this->sub_folder     = get_sub_folder();
        $this->time           = time();

        $this->admin_name     = trim(_addslashes(strip_tags(getenv('USER_USERNAME'))));
        $this->admin_email    = trim(strtolower(_addslashes(strip_tags(getenv('USER_EMAIL')))));
        $this->admin_pass     = trim(_addslashes(strip_tags(getenv('USER_PASSWORD'))));

        $this->db_prefix      = trim(strtolower(_addslashes(strip_tags(getenv('DB_PREFIX')))));
        $this->db_hostname    = trim(_addslashes(strip_tags(getenv('DB_HOSTNAME'))));
        $this->db_name        = trim(_addslashes(strip_tags(getenv('DB_NAME'))));
        $this->db_username    = trim(_addslashes(strip_tags(getenv('DB_USER'))));
        $this->db_password    = trim(_addslashes(strip_tags(getenv('DB_PASSWORD'))));

        return 'Edit Link Table';
    }

    public function up(Schema $schema): void
    {
        // Edit table
        $this->addSql("ALTER TABLE `{$this->db_prefix}links` ADD `direct_redirection` BOOLEAN DEFAULT 0");
        $this->addSql("ALTER TABLE `{$this->db_prefix}links` ADD `keywords` TEXT(500)");
        $this->addSql("ALTER TABLE `{$this->db_prefix}links` ADD `description` TEXT(600)");
    }

    public function down(Schema $schema): void
    {
        $this->addSql("ALTER TABLE `{$this->db_prefix}links` DROP COLUMN `direct_redirection`");
        $this->addSql("ALTER TABLE `{$this->db_prefix}links` DROP COLUMN `keywords`");
        $this->addSql("ALTER TABLE `{$this->db_prefix}links` DROP COLUMN `description`");
    }
}
