<?php

declare(strict_types=1);

namespace ADLinker\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20221206123137 extends AbstractMigration
{
    public function getDescription(): string
    {
        $this->site_name      = trim(_addslashes(strip_tags(getenv('SITE_NAME'))));
        $this->support_email  = trim(strtolower(_addslashes(strip_tags(getenv('SITE_CONTACT_US_EMAIL')))));
        $this->sub_folder     = get_sub_folder();
        $this->time           = time();

        $this->admin_name     = trim(_addslashes(strip_tags(getenv('USER_USERNAME'))));
        $this->admin_email    = trim(strtolower(_addslashes(strip_tags(getenv('USER_EMAIL')))));
        $this->admin_pass     = trim(_addslashes(strip_tags(getenv('USER_PASSWORD'))));

        $this->db_prefix      = trim(strtolower(_addslashes(strip_tags(getenv('DB_PREFIX')))));
        $this->db_hostname    = trim(_addslashes(strip_tags(getenv('DB_HOSTNAME'))));
        $this->db_name        = trim(_addslashes(strip_tags(getenv('DB_NAME'))));
        $this->db_username    = trim(_addslashes(strip_tags(getenv('DB_USER'))));
        $this->db_password    = trim(_addslashes(strip_tags(getenv('DB_PASSWORD'))));

        return 'Template Theme Colors';
    }

    public function up(Schema $schema): void
    {
        $this->addSql("INSERT INTO `{$this->db_prefix}settings` (option_name, option_value, autoload) VALUES
            ('registration_bonus', '0', 'yes'),

            ('theme_primary_color', '350, 96.3%, 42.9%', 'yes'),
            ('theme_secondary_color' , '240,36.4%,21%', 'yes'),

            ('theme_dashboard_primary_color' , '240,27.5%,20%', 'yes'),
            ('theme_dashboard_secondary_color' , '240,27.5%,20%', 'yes'),
            ('theme_dashboard_navbar_color' , '240,27.5%,20%', 'yes'),

            ('theme_home_image_jumbotron' , '', 'yes'),
            ('theme_home_image_1' , '', 'yes'),
            ('theme_home_image_2' , '', 'yes'),
            ('theme_home_image_3' , '', 'yes'),
            ('theme_home_image_4' , '', 'yes')
        ");

    }

    public function down(Schema $schema): void
    {
        $this->addSql("DELETE FROM `{$this->db_prefix}settings` WHERE option_name in (
            'theme_primary_color',
            'theme_secondary_color',
            'theme_dashboard_primary_color',
            'theme_dashboard_secondary_color',
            'theme_dashboard_navbar_color',
            'registration_bonus',

            'theme_home_image_jumbotron',
            'theme_home_image_1',
            'theme_home_image_2',
            'theme_home_image_3',
            'theme_home_image_4'
        )");

    }
}
