<?php


function get_tables($db_prefix='my_')
{
	$tables = [
		'contact',
		'languages',
		'links',
		'news',
		'online',
		'pages',
		'settings',
		'statistics',
		'updates',
		'users',
		'usersmeta',
	];

	// adding $db_prefix
	foreach($tables as $key => $table_name)
	{
		$tables[$key] = $db_prefix.$table_name;
	}

	return $tables;
}

function get_base_url($sub_folder)
{
	return get_url_schema()."://".$_SERVER['HTTP_HOST'].$sub_folder;
}

function get_url_schema()
{
	return isset($_SERVER['HTTPS']) and $_SERVER['HTTPS'] ? 'https' : 'http';
}

function get_root_path()
{
	if (isset($_SERVER['SITE_SUBDIRECTORY']) && $_SERVER['SITE_SUBDIRECTORY'] != "/")
		return "/".trim($_SERVER['SITE_SUBDIRECTORY'], '/')."/";
	
	return "/";
}

function get_sub_folder()
{
	return get_root_path();
}


function _addslashes ($str)
{
	if (get_magic_quotes_gpc())
	{
		return $str;
	}
	else
	{
		return addslashes($str);
	}
}


function get_default_countries()
{
	$countries = [];

	foreach(countries() as $k => $country)
	{
		$countries[] = [
			'name' => $country['name'],
			'code' => strtolower($country['iso_3166_1_alpha2']),
		];
	}

	return $countries;
}

function is_demo()
{
    if (isset($_ENV['SITE_DEMO_MODE']) && ($_ENV['SITE_DEMO_MODE'] == '1' || $_ENV['SITE_DEMO_MODE'] == 'true'))
        return true;

    return false;
}
