<?php

// messages list to store messages to show it later.
$ALERT_MESSAGES = [];

// register all Hooks in the glocal scoop to be accessable everywhere.
require_once APPPATH."helpers/register_hooks.php";

$API_KEY = isset($_SERVER['API_KEY'])? $_SERVER['API_KEY'] : '6ok5fzI9CnmwX9lxUSMhZC7SdI3DVynX';
$ENVATO_LC = isset($_SERVER['ENVATO_PURCHASE_CODE'])? $_SERVER['ENVATO_PURCHASE_CODE'] : null;

/*
	MY_controller class is a midleware for checking permissions and applying pre-actions.
*/
class MY_controller extends CI_controller
{
	public function __construct()
	{
		define('MICROTIME', microtime(TRUE));

		parent::__construct();
		$this->load->model('cms_model');
		$this->cms_model->site_config(); // get the configuration of my site :D
		date_default_timezone_set(config_item('default_timezone'));

		// language
		$this->check_language();

		//$this->lc_checker();

		// register online visitors
		$this->cms_model->onlineVisitors();
		$this->cms_model->is_closed();
		$this->cms_model->test_login_using_cookie();
	}

	public function __destruct()
	{
		global $ALERT_MESSAGES;
	    if (is_array($ALERT_MESSAGES))
	    {
		    set_cookie('ALERT_MESSAGES', json_encode($ALERT_MESSAGES), 86500000);
	    }
	}

	private function check_language()
	{
		$langs = get_langs();
		$default_lang = get_default_lang();
		$language = $default_lang; // get and use the default language (default value).
		$sym = $this->input->cookie('lang', true);

		// check the cookie
		if (isset($_GET['lang']) && $_GET['lang'] != '')
		{
			// create new cookie
			$sym = $this->input->get('lang', true); // en, ar, ...
			set_cookie('lang', $sym, 30*24*3600); // 30 days
		}

		// Getting and set language by cookie.
		if ($sym != '')
		{
			foreach ($langs as $k => $l)
			{
				if ($l['symbol'] == $sym)
				{
					$language = $l;
					break;
				}
			}
		}

		$this->config->set_item('validLang', $language);
		$this->config->set_item('languages', $langs);
	}

	private function lc_checker()
	{
		// check for cache.
		$cache_file = APPPATH.'cache/lc_checker_timestamp';

		// check if it's admin panel.
		if (strpos($_SERVER['REQUEST_URI'], 'adminpanel') and !is_demo())
		{
			$timestamp = (int)@file_get_contents($cache_file);
			$deltatime = time() - $timestamp;

			if ($deltatime > 86400 or !file_exists($cache_file)) // 24 hours.
			{
				// do a license checking.
				if ($this->is_bk_listed())
				{
					die("<h1>Invalid License, probably has been blacklisted.</h1>");
				}

				if ($this->check_now())
				{
					// create cache
					// refresh the timestamp
					file_put_contents($cache_file, time());
				}
				else
				{
					// do a message notification to the fack client.
					die("<h2>Invalid License, please ensure your Envato purchase code is correct in '.env' file or contact the support.</h2>");
				}
			}
		}

	}

	private function check_now()
	{
		global $ENVATO_LC, $API_KEY;

		function VEPC($code_to_verify, $api_key){
		    $ch = curl_init();
		    $agents = array(
		        "Mozilla/5.0 (Linux; Android 8.0.0; SM-G960F Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36",
		        "Mozilla/5.0 (Linux; Android 6.0.1; SM-G935S Build/MMB29K; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/55.0.2883.91 Mobile Safari/537.36",
		        "Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) FxiOS/13.2b11866 Mobile/16A366 Safari/605.1.15",
		        "Mozilla/5.0 (iPhone9,3; U; CPU iPhone OS 10_0_1 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Mobile/14A403 Safari/602.1",
		    );
		    $agent = $agents[array_rand($agents)];
		    curl_setopt_array($ch, array(
		    CURLOPT_URL => "https://api.envato.com/v3/market/author/sale?code=".$code_to_verify."",
		    CURLOPT_RETURNTRANSFER => true,
		    CURLOPT_TIMEOUT => 20,
		    CURLOPT_HTTPHEADER => array(
		        "Authorization: Bearer " . $api_key . "",
		        "User-Agent: ". $agent .""
		    )
		    ));
		    $output = json_decode(curl_exec($ch), true);
		    curl_close($ch);
		    return $output;
		}

		// check license
		$result = VEPC($ENVATO_LC, $API_KEY);

		if (isset($result['license']) && ($result['license'] == "Regular License" or $result['license'] == "Extended License"))
			return true;

		return false;
	}

	// check if a license is blacklisted
	private function is_bk_listed()
	{
		global $ENVATO_LC;
		// check banned list
		$banned_list = @json_decode(@file_get_contents('https://mr4web.com/resources/envato_banned_list'), true);

		if (isset($banned_list['banned_list']) && in_array($ENVATO_LC, $banned_list['banned_list']))
			return true;

		return false;
	}
} // end class block


?>
