<?php
// messages list to store messages to show it later.
$ALERT_MESSAGES = [];

// register all Hooks in the glocal scoop to be accessable everywhere.
require_once APPPATH."helpers/register_hooks.php";

$API_KEY = isset($_SERVER['API_KEY'])? $_SERVER['API_KEY'] : 'af27c8cd3f9134e04f0a8aa9dbbfb18e8d4847d1';
$ENVATO_LC = isset($_SERVER['ENVATO_PURCHASE_CODE'])? $_SERVER['ENVATO_PURCHASE_CODE'] : null;

/*
	MY_controller class is a midleware for checking permissions and applying pre-actions.
*/
class MY_controller extends CI_controller
{
	public function __construct()
	{
		define('MICROTIME', microtime(TRUE));

		parent::__construct();

		$this->load->model('cms_model');
		$this->cms_model->site_config(); // get the configuration of my site :D
		date_default_timezone_set(config_item('default_timezone'));

		// set main domain
		$this->set_main_domain();

		// language
		$this->check_language();

		//$this->lc_checker();

		// register online visitors
		$this->cms_model->onlineVisitors();
		$this->cms_model->is_closed();

		// deny package domain (except for go page)
		$this->deny_package_domains();

		$this->cms_model->test_login_using_cookie();
	}

	public function __destruct()
	{
		global $ALERT_MESSAGES;
	    if (is_array($ALERT_MESSAGES))
	    {
		    //set_cookie('ALERT_MESSAGES', json_encode($ALERT_MESSAGES), time()+30000);
		    //setcookie('ALERT_MESSAGES', json_encode($ALERT_MESSAGES), time()+30000);
	    }
	}

	private function check_language()
	{
		$langs = get_langs();
		$default_lang = get_default_lang();
		$language = $default_lang; // get and use the default language (default value).
		$sym = $this->input->cookie('lang', true);

		// check the cookie
		if (isset($_GET['lang']) && $_GET['lang'] != '')
		{
			// create new cookie
			$sym = $this->input->get('lang', true); // en, ar, ...
			set_cookie('lang', $sym, 30*24*3600); // 30 days
		}

		// Getting and set language by cookie.
		if ($sym != '')
		{
			foreach ($langs as $k => $l)
			{
				if ($l['symbol'] == $sym)
				{
					$language = $l;
					break;
				}
			}
		}

		$this->config->set_item('validLang', $language);
		$this->config->set_item('languages', $langs);
	}

	private function lc_checker()
	{
		// check for cache.
		$cache_file = APPPATH.'cache/lc_checker_timestamp';

		// check if it's admin panel.
		if (strpos($_SERVER['REQUEST_URI'], 'adminpanel') and !is_demo())
		{
			$timestamp = (int)@file_get_contents($cache_file);
			$deltatime = time() - $timestamp;

			if ($deltatime > 86400 or !file_exists($cache_file)) // 24 hours.
			{
				# stop if the license API is offline.
				if (!$this->is_up('http://license.mr4web.com/api/is_up/'))
				{
					return null;
				}
				// do a license checking.
				$message = "";
				if ($this->check_now($message))
				{
					// create cache
					// refresh the timestamp
					file_put_contents($cache_file, time());
				}
				else
				{
					// do a message notification to the fack client.
					die("<h2>".$message."</h2>");
				}
			}
		}

	}

	private function check_now(&$message)
	{
		global $ENVATO_LC, $API_KEY;

		function VEPC($code_to_verify, $api_key){
			$host = isset($_SERVER['HTTP_HOST'])? $_SERVER['HTTP_HOST'] : "" ;

		    $ch = curl_init();
		    $agents = array(
		        "Mozilla/5.0 (Linux; Android 8.0.0; SM-G960F Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36",
		        "Mozilla/5.0 (Linux; Android 6.0.1; SM-G935S Build/MMB29K; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/55.0.2883.91 Mobile Safari/537.36",
		        "Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) FxiOS/13.2b11866 Mobile/16A366 Safari/605.1.15",
		        "Mozilla/5.0 (iPhone9,3; U; CPU iPhone OS 10_0_1 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Mobile/14A403 Safari/602.1",
		    );
		    $agent = $agents[array_rand($agents)];
		    curl_setopt_array($ch, array(
		    // e.g: CURLOPT_URL => "http://localhost.ext:8000/api/check_license/",
		    CURLOPT_URL => "http://license.mr4web.com/api/check_license/",
		    CURLOPT_SSL_VERIFYPEER => false,
		    CURLOPT_SSL_VERIFYHOST => 0,
		    CURLOPT_RETURNTRANSFER => true,
		    CURLOPT_TIMEOUT => 20,
		    CURLOPT_POST => true,
		    CURLOPT_FOLLOWLOCATION => true,
			CURLOPT_POSTFIELDS => [
				"license_code" => $code_to_verify,
				"host" => $host
			],
		    CURLOPT_HTTPHEADER => array(
		    	"Authorization: Bearer " . $api_key . "",
		        "User-Agent: ". $agent .""
		    )
		    ));
		    $output = json_decode(curl_exec($ch), true);
		    curl_close($ch);
		    return $output;
		}

		// check license
		$result = VEPC($ENVATO_LC, $API_KEY);

		if (isset($result['status']) && $result['status'] == "ACTIVE")
			return true;

		if(isset($result['message']))
			$message = $result['message'];

		return false;
	}

	private function is_up($url)
	{
		$content = @json_decode(@file_get_contents($url), true);
		if (isset($content['is_up']) && $content['is_up'] == true)
			return true;
		return false;
	}

	private function deny_package_domains()
	{
		if (!is_go_page())
			deny_package_domains();
	}


	private function set_main_domain()
	{
		if (empty(get_config_item('main_domain')))
		{
			$main_domain = $_SERVER['HTTP_HOST'];
			set_config_item('main_domain', $main_domain);
		}
	}

} // end class block


?>
