<!-- Content Header (Page header) -->
<section class="content-header">
    <h1><i class='fa fa-flag-o'></i> <?php echo $title; ?></h1>
</section>

<!-- Main content -->
<section class="content">
    <div class="box box-warning">
        <div class="box-body">
        	<div class="row">
                <div class="col-md-12"><?php echo get_messages(true) ?></div>
                <div class='col-lg-12 text-right'>
                    <a href='./announcements/add' class='btn btn-primary'><i class='fa fa-plus-circle fa-fw'></i> Add Announcement</a>
                    <br>
                    <br>
                </div>
            </div>
            <div class="row">
                <div class="col-lg-12">
                    <table class="table table-striped">
                        <thead>
                            <tr>
                                <th>ID</th>
                                <th>Message</th>
                                <th>Availability</th>
                                <th>Status</th>
                                <th>Created</th>
                                <th>Actions</th>
                            </tr>
                        </thead>
                        <tbody>
                            <?php if ($announcements): ?>
                                <?php foreach($announcements as $ann): ?>
                                    <tr>
                                        <td><?=$ann->id ?></td>
                                        <td><?=$ann->message ?></td>
                                        <td><?=get_announcement_availability($ann->availability, true) ?></td>
                                        <td><?=get_status($ann->status, true) ?></td>
                                        <td><?=date(get_config_item('time_format'), strtotime($ann->created)) ?></td>
                                        <td>
                                            <a href='announcements/edit/<?=$ann->id ?>' class='btn btn-xs btn-primary'><i class='fa fa-fw fa-pencil'></i> Edit</a>
                                            <a class='btn btn-xs btn-danger deleteAnnoucement' data-id='<?=$ann->id ?>'><i class='fa fa-fw fa-trash'></i>Delete</a>
                                        </td>
                                    </tr>
                                <?php endforeach ?>
                            <?php else: ?>
                                <tr><td colspan='6' class='text-center'>No Announcements.</td></tr>
                            <?php endif ?>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</section>

