<!-- Content Header (Page header) -->
<section class="content-header">
    <h1><i class="fa fa-fw fa-globe"></i> <?=$title ?> <i class="fa fa-fw fa-info-circle" title='Custom domains are meant just for links shortening only.'></i></h1>
</section>

<!-- Main content -->
<section class="content">
    <div class="box box-warning">
        <div class="box-body">
            <div class='row'>
                <div class="col-md-12"><?php echo get_messages(true) ?></div>
                <div class='col-lg-12 text-right'>
                        <a href='./custom_domains/add' class='btn btn-primary'><i class='fa fa-plus-circle fa-fw'></i> Add Custom Domain</a>
                        <br>
                        <br>
                </div>
            </div>
            <div class='row'>
                <div class='col-lg-12'>
                    <table class='table'>
                        <tr>
                            <th>ID</th>
                            <th>Domain name</th>
                            <th>Status <i class="fa fa-fw fa-info-circle" title='Allow users to use this domain for links shortening.'></i></th>
                            <th>Options</th>
                        </tr>
                        <?php
                        $i = 0;
                        foreach ($domains as $k => $domain)
                        {
                            echo "<tr>";
                                echo "<td>".$i."</td>";
                                echo "<td>".$domain->domain_name."</td>";
                                echo "<td>";
                                if ($domain->status)
                                    echo "<span class='badge label-success' title='Available to use on the website'>On</span>";
                                else
                                    echo "<span class='badge label-danger' title='is not Available to use on the website'>Off</span>";
                                echo "</td>";

                                echo "<td>";
                                    echo "<a href='".base_url($page_path."/custom_domains/edit/".$domain->id)."' class='btn btn-primary btn-xs'><i class='fa fa-pencil fa-fw'></i> Edit</a> ";
                                echo "</td>";
                            echo "</tr>";
                            $i++;
                        }
                        ?>
                    </table>
                </div>
            </div>

        </div>
    </div>

    <div class="box">
        <div class="box-body">
            <div class="row">
                <div class="col-md-4 col-sm-6 col-xs-8">
                    <div class="text-success" style="display: flex; align-items: center; font-size: 1.2em;">
                        <i class="fa fa-shield fa-fw fa-2x" aria-hidden="true"></i> <i>Main Domain Protection.</i> <i class="fa fa-fw fa-info-circle" title="It means, don't use main domain for links shortening (To avoid domain blacklisting)."></i>
                    </div>
                </div>
                <div class="col-md-2 col-sm-2 col-xs-4 text-center" id="domain-protection-status">
                    <?php if(intval(get_config_item('main_domain_protection')) == 1): ?>
                        <span class="badge label-success">On</span>
                    <?php else: ?>
                        <span class="badge label-secondary">Off</span>
                    <?php endif ?>
                </div>
                <div class="col-md-2 col-sm-4 col-xs-12">
                    <button class="btn btn-success btn-block" id="domain-protection"><?=(intval(get_config_item('main_domain_protection')) == 1)? "Disable" : "Enable" ?></button>
                </div>
            </div>
            <div class="alert alert-info" style="margin: 1em 0 0 0"><i class="fa fa-info fa-fw"></i> By enabling "Main Domain Protection", that means, you cannot use your main domain for links shortening (use Custom Domains instead), it's useful for protecting your main domain from getting blocked/blacklisted on the internet.</div>
        </div>
    </div>

    <div class="box box-warning">
        <div class="box-body">
            <div class="alert alert-secondary">
                <i class="fa fa-fw fa-info-circle"></i>
                <b>Important Note:</b><br><br>
                In order to add/use a custom domain with your links, ensure to point it first to your web hosting, to the same server/hosting/IP by adding an "A" DNS Record (from your Cpanel or domain provider) in order to function properly.<br><br>
                For adding your whole domain as Custom Domain:
                <pre>
TYPE            HOST            VALUE
 A               @                your-hosting-IP
 A              www               your-hosting-IP</pre>

                For adding your sub domain as a Custom Domain (<i>https://sub.domain.com</i>):
                <pre>
TYPE            HOST            VALUE
 A              sub              your-hosting-IP</pre>

                Then, add an "<b>alias</b>" to your main domain from your Hosting provider (e.g. Cpanel, Plesk, DirectAdmin) (see tutorial video):<br>
                <b><a href="https://www.youtube.com/watch?v=pwKUvIVT3No" target="_blank" style="color: #555">https://www.youtube.com/watch?v=pwKUvIVT3No</a></b>
            </div>

            <div class="alert alert-info"><i class="fa fa-info fa-fw"></i> DNS records may take up to 24 hours to take effect (but usually, it takes just about 15 to 30 minutes).</div>
        </div>
    </div>
</section>

