<!-- Content Header (Page header) -->
<section class="content-header">
    <h1><i class='fa fa-link'></i> <?php echo $title; ?></h1>
</section>

<!-- Main content -->
<section class="content">
	<div class='row'>
		<div class='col-sm-9 col-lg-10'>
			<div class='form-group'>
				<form action='<?php echo base_url($page_path); ?>/links' method='get'>
					<div class="input-group">
						<input type="text" class="form-control" name="search" placeholder="Search for links by link its title and slug."
						<?php
						if (isset($search))
						{
							echo "value='".htmlentities($search,ENT_QUOTES)."'";
						}
						?>
						>
						<span class="input-group-btn">
							<button class="btn btn-warning"><i class="fa fa-search"></i> Search</button>
						</span>
					</div>
				</form>
			</div>
		</div>
		<div class="col-sm-3 col-lg-2 text-center">
			<a href="<?=base_url('account/addlinks') ?>" class="btn btn-success btn-block"><i class='fa fa-fw fa-lg fa-chain-broken'></i> Create New Link</a>
		</div>
	</div>

	<div class="row">
		<div class="col-sm-12"><?= "<i>Results: ".$all_items."</i>" ?></div>
	</div>

	<div class="row">
	    <div class="col-lg-12">
	    	<? if ($links->num_rows() > 0): ?>
	    		<? foreach ($links->result_object() as $link): ?>
		    		<div class="panel panel-default">
		    			<div class="panel-heading">
		    				<a href='<?=get_domains($link->domain).$link->slug ?>' target='_blank'>
		    					<b><i class='fa fa-link fa-fw'></i> <?=$link->title ?></b>
		    				</a>
		    				<? if ($link->status == 1): ?>
		    					<span class='badge label-success' title='<?=langLine('account.mylinks.span.7', false) ?>'><?=langLine('account.mylinks.span.8', false) ?></span>
		    				<? else: ?>
		    					<span class='badge label-danger' title='<?=langLine('account.mylinks.span.9', false) ?>'><?=langLine('account.mylinks.span.10', false) ?></span>
		    				<? endif ?>

		    				<? if ($link->direct_redirection == 1): ?>
		    					<span class="badge badge-primary">Direct Redirection</span>
		    				<? endif; ?>
		    			</div>
		    			<div class="panel-body">
		    				<div class="row">
		    					<div class="col-md-10">
		    						<div class="row">
		    							<div class='col-md-6'>
		    								<span>Shortened link:</span>
		    								<div class='input-group input-group-sm'>
		    									<span class='input-group-btn'>
		    										<button class='btn btn-secondary copy' type='button'>Copy</button>
		    									</span>
		    									<input class='form-control' dir='ltr' type='text' value='<?=get_domains($link->domain).$link->slug ?>' >
		    								</div>
		    							</div>

		    							<div class='col-md-6'>
		    								<span>Original link:</span>
		    								<div class='input-group input-group-sm'>
		    									<span class='input-group-btn'>
		    										<button class='btn btn-secondary copy' type='button'>Copy</button>
		    									</span>
		    									<input class='form-control' dir='ltr' type='text'value='<?=htmlentities(decode($link->url), ENT_QUOTES) ?>' >
		    								</div>
		    							</div>
		    						</div>
		    					</div>
		    					<div class="col-md-2">
		    						<div class='action'>
		    							<a class='btn btn-primary btn-sm btn-block' href="links/edit/<?=$link->slug ?>" ><i class='fa fa-pencil'></i> Edit</a>

		    							<span class='btn btn-danger btn-sm delete_link btn-block' id='<?=$link->id ?>' ><i class='fa fa-trash'></i> Delete</span>
		    						</div>
		    					</div>
		    				</div>
		    			</div>
		    			<div class="panel-footer">
		    				<div class="row">
		    					<div class="col-lg-2 col-md-3 col-xs-4">
		    						<i class='fa fa-clock-o'></i> <b><?=date(get_config_item("time_format"), strtotime($link->created)) ?></b>
		    					</div>
		    					<div class="col-lg-1 col-md-2 col-xs-2">
		    						<i class='fa fa-eye fa-fw'></i> <b><?=intval($link->total_views) ?></b>
		    					</div>
		    					<div class="col-lg-1 col-md-2 col-xs-2">
		    						<b>#ID: <?=$link->id ?></b>
		    					</div>
		    					<div class="col-lg-2 col-md-3 col-xs-4">
		    						<b>Earnings: <?=get_currency()['symbol'].round_balance($link->total_earnings) ?></b>
		    					</div>
		    				</div>
		    			</div>
		    		</div>
		    	<? endforeach ?>
	    	<div class='row'>
	    		<div class='col-lg-12'>
	    			<div class='pull-left'>
	    				<?=pagination($all_items,$links_per_page,base_url($page_path.'/links/p')) ?>
	    			</div>
	    			<div class='pull-right'><i><?=$page."/".$all_pages." pages" ?></i></div>
	    			<div class='clearfix'></div>
	    		</div>
	    	</div>
	    	<? else: ?>
	    		<div class='alert alert-info'><i class='fa fa-info-circle'></i> No links found!</div>
	    	<? endif ?>
	    </div>
	</div>

</section>
