<!-- Content Header (Page header) -->
<section class="content-header">
    <h1><i class="fa fa-fw fa-th-large"></i> <?=$title ?></h1>
</section>

<!-- Main content -->
<section class="content">
	<div class="row">
		<div class="col-md-12">
			<div class="box box-info">
				<div class="box-body">
					<label>Note:</label>
					<i>You'll find the best color combination suggestions on <b><a href="https://coolors.co/palettes/trending" target="_blank">Coolors.co</a></b> website.</i>
				</div>
			</div>
		</div>
	</div>

	<form autocomplete="off" method='POST' id="save-theme-form">
	    <div class="box box-warning">
	    	<div class="box-header">
	    		<h3>Global Template Settings</h3>
	    	</div>
	        <div class="box-body">
	    		<div class="row">
	    			<div class="col-md-5">
	    				<div class="form-group">
	    					<label>Primary Color:</label>
	    					<input type="color" list="nice-colors" name="primary-color" default-value="<?=$theme_configs->theme_primary_color ?>">
	    				</div>
	    				<div class="form-group" style="margin-bottom: 5em;">
	    					<label>Secondary Color:</label>
	    					<input type="color" list="nice-secondary-colors" name="secondary-color" default-value="<?=$theme_configs->theme_secondary_color ?>">
	    				</div>
	    				<div class="form-group">
	    					<label>Home Jumbotron Image:</label>
	    					<input type="url" name="home_image_jumbotron" class="form-control" placeholder="e.g. https://i.imgur.com/4JPzJbr.png" value="<?=get_config_item('theme_home_image_jumbotron') ?>">
	    				</div>
	    				<div class="form-group">
	    					<label>Home Image 1:</label>
	    					<input type="url" name="home_image_1" class="form-control" placeholder="e.g. https://i.imgur.com/4JPzJbr.png" value="<?=get_config_item('theme_home_image_1') ?>">
	    				</div>
	    				<div class="form-group">
	    					<label>Home Image 2:</label>
	    					<input type="url" name="home_image_2" class="form-control" placeholder="e.g. https://i.imgur.com/4JPzJbr.png" value="<?=get_config_item('theme_home_image_2') ?>">
	    				</div>
	    				<div class="form-group">
	    					<label>Home Image 3:</label>
	    					<input type="url" name="home_image_3" class="form-control" placeholder="e.g. https://i.imgur.com/4JPzJbr.png" value="<?=get_config_item('theme_home_image_3') ?>">
	    				</div>

	    				<div class="form-group">
	    					<label>Home Contact Image:</label>
	    					<input type="url" name="home_image_4" class="form-control" placeholder="e.g. https://i.imgur.com/4JPzJbr.png" value="<?=get_config_item('theme_home_image_4') ?>">
	    				</div>
	    			</div>
	    			<div class="col-md-7">
	    				<label>Notes:</label><br>
	    				<ul>
	    					<li>
			    				<i>This section will affect the following pages/templates:<br>
			    					- Home page.<br>
			    					- Login & register pages.<br>
			    					- "Go" page (landing / redirection page).<br>
			    					- Standard pages (e.g: contact us, Terms of Use, Privacy Policy, ...etc).<br>
			    				</i>
	    					</li>
	    					<li>
			    				<i>Default images will be used if no images have been set.</i><br>
	    					</li>
	    					<li>
			    				<i>You can use <b><a href="https://imgur.com/upload">imgur.com</a></b> website to upload your images.</i>
	    					</li>
	    					<li>
	    						<i>You can change texts and paragraphs in files at "application/language/english"</i>
	    					</li>
	    				</ul>
	    			</div>
	    		</div>
	        </div>
	    </div>

	    <div class="box box-info">
	    	<div class="box-header">
	    		<h3>Admin Dashboard</h3>
	    	</div>
	        <div class="box-body">
		        <div class="col-md-5">
		        	<div class="form-group">
		        		<label>Dashboard Primary Color:</label>
		        		<input type="color" list="nice-colors" name="dashboard-primary-color" default-value="<?=$theme_configs->theme_dashboard_primary_color ?>">
		        	</div>
		        	<div class="form-group">
		        		<label>Dashboard Secondary Color:</label>
		        		<input type="color" list="nice-secondary-colors" name="dashboard-secondary-color" default-value="<?=$theme_configs->theme_dashboard_secondary_color ?>">
		        	</div>
		        	<div class="form-group">
		        		<label>Dashboard Side NavBar Color:</label>
		        		<input type="color" list="nice-colors" name="dashboard-navbar-color" default-value="<?=$theme_configs->theme_dashboard_navbar_color ?>">
		        	</div>
	        	</div>
	        	<div class="col-md-7">
	        		<label>Note:</label><br>
	        		<i>Will affect just the Adminpanel (Admin's Dashboard).</i>
	        	</div>
	        </div>
	    </div>
	    <datalist id="nice-colors">
	    	<option value="#252541"></option>
	    	<option value="#d81159"></option>
	    	<option value="#D70427"></option>
	    	<option value="#6a994e"></option>
	    	<option value="#80b918"></option>
	    	<option value="#5a189a"></option>
	    	<option value="#7b2cbf"></option>
	    	<option value="#fdc500"></option>
	    	<option value="#faa307"></option>
	    	<option value="#fe7f2d"></option>
	    	<option value="#4C205B"></option>
	    	<option value="#2a9d8f"></option>
	    	<option value="#3c7a89"></option>
	    	<option value="#264653"></option>
	    	<option value="#5e548e"></option>
	    </datalist>

	    <datalist id="nice-secondary-colors">
	    	<option value="#252541"></option>
	    	<option value="#22224A"></option>
	    	<option value="#333533"></option>
	    	<option value="#023e8a"></option>
	    	<option value="#003566"></option>
	    	<option value="#354f52"></option>
	    	<option value="#403d39"></option>
	    	<option value="#3d5a80"></option>
	    	<option value="#723d46"></option>
	    	<option value="#4f5d75"></option>
	    	<option value="#5e548e"></option>
	    	<option value="#6b705c"></option>
	    	<option value="#3c7a89"></option>
	    	<option value="#00296b"></option>
	    	<option value="#1a759f"></option>
	    </datalist>

	 	<button type="submit" class="btn btn-primary" id="save-theme">Save Theme Settings</button>
	</form>
</section>

