<!-- Content Header (Page header) -->
<section class="content-header">
    <h1><i class='fa fa-usd'></i> <?php echo $title; ?></h1>
</section>

<!-- Main content -->
<section class="content">
    <div class="box box-warning">
        <div class="box-body">
        	<div class="row">
                <div class="col-md-12"><?php echo get_messages(true) ?></div>
            </div>
            <div class="row">
                <form method="get">
                    <div class="col-md-6">
                        <div class="form-group">
                            <input type="text" name="q" value="<?=isset($q) ? $q : '' ?>" class="form-control" placeholder="eg. Search by ID, Withdrawal Account or user's email." >
                        </div>
                    </div>
                    <div class="col-md-2">
                        <div class="form-group">
                            <select class="form-control" name="status" <?=(isset($status_id))? "data-default='$status_id'" : '' ?> >
                                <option value="all" >------ All Statuses ------</option>
                                <?php foreach (get_all_req_statuses() as $k => $status): ?>
                                    <option value="<?=$k ?>" ><?=$status ?></option>
                                <?php endforeach ?>
                            </select>
                        </div>
                    </div>
                    <div class="col-md-2">
                        <div class="form-group">
                            <select class="form-control" name="method" <?=(isset($method_id))? "data-default='$method_id'" : '' ?> >
                                <option value="all">------ All Methods ------</option>
                                <?php foreach ($methods as $k => $method): ?>
                                    <option value="<?=$method->id ?>" ><?=$method->name ?></option>
                                <?php endforeach ?>
                            </select>
                        </div>
                    </div>
                    <div class="col-md-2">
                        <button type="submit" class="btn btn-warning btn-block">Search</button>
                    </div>
                </form>
            </div>
            <div class="row">
                <div class="col-lg-12">
                    <table class="table table-striped">
                        <thead>
                            <tr>
                                <th>ID</th>
                                <th>User</th>
                                <th>Amount</th>
                                <th>Withdrawal Method</th>
                                <th class="w-25">Withdrawal Account</th>
                                <th>Created</th>
                                <th>Status</th>
                                <th>Actions</th>
                            </tr>
                        </thead>
                        <tbody>
                            <?php
                            $currency = get_currency();
                            if ($result):
                                foreach($result as $row): ?>
                                    <tr>
                                        <td class='td-vertical'><?=$row->id ?></td>
                                        <td class='td-vertical'>
                                            <div class='row'>
                                                <div class='col-xs-3'>
                                                    <a href='u/edit/<?=$row->user_id ?>'>
                                                        <img src='/uploads/users/profile-images/<?=md5($row->user_token) ?>.png?v=<?=time()?>' class='img-circle' width='50' >
                                                    </a>
                                                </div>
                                                <div class='col-xs-6'>
                                                    <a href='u/edit/<?=$row->user_id?>'>
                                                        <b><?=$row->username ?></b><br>(<?=$row->email ?>)
                                                    </a>
                                                </div>
                                            </div>
                                        </td>
                                        <td class='td-vertical'><?=$currency['symbol'].$row->withdraw_amount?></td>
                                        <td class='td-vertical'><?=$row->name?></td>
                                        <td class='td-vertical'><?=$row->withdrawal_account?></td>
                                        <td class='td-vertical'><?=date(get_config_item('time_format'), strtotime($row->created)) ?></td>

                                        <td class='td-vertical'>
                                            <select name='status' class='form-control statusSelector' data-default='<?=$row->status?>'>
                                                <? foreach(get_all_req_statuses() as $k => $v): ?>
                                                    <option value='<?=$k?>'><?=$v?></option>
                                                <? endforeach ?>
                                            </select>
                                        </td>

                                    <td class='td-vertical'>
                                            <a class='btn btn-xs btn-primary saveWithdrowRequestStatus' data-status-id='<?=$row->status?>' id='<?=$row->id?>'><i class='fa fa-fw fa-check'></i> Save status</a>
                                            <a class='btn btn-xs btn-danger deleteWithdrowRequest' id='<?=$row->id?>'><i class='fa fa-fw fa-trash'></i>Delete withdraw</a>
                                        </td>
                                    </tr>
                                <? endforeach ?>
                            <? else: ?>
                                <tr><td colspan='8' class='text-center'>No withdrawal requests.</td></tr>
                            <? endif ?>
                        </tbody>
                    </table>
                </div>
                <div class="col-lg-12">
                    <ul>
                        <li><b>Pending</b>: The payment is being checked.</li>
                        <li><b>Approved</b>: The payment has been approved and is waiting to be sent.</li>
                        <li><b>Complete</b>: The payment has been successfully sent to your payment account.</li>
                        <li><b>Cancelled</b>: The payment has been cancelled.</li>
                        <li><b>Returned</b>: The payment has been returned to your account.</li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
</section>

