<link type='text/css' rel='stylesheet' href='<?php echo base_url(); ?>assets/js/morris/morris.css' >
<script type='text/javascript' src='<?php echo base_url(); ?>assets/js/morris/raphael-min.js'></script>
<script type='text/javascript' src='<?php echo base_url(); ?>assets/js/morris/morris.min.js'></script>

<div class='container account'>
	<div class='row'>
		<?=$sidebar ?>

		<div class='col-md-9'>
			<div class='row'>
				<div class='col-lg-12'>
					<h1><i class="fa fa-fw fa-area-chart"></i> <?php langLine('account.dashboard.span.1') ?></h1>
					<hr>
				</div>
			</div>

			<div class="row">
			    <div class="col-md-12 text-center">
			    	<i class="fa fa-fw fa-calendar fa-2x"></i>
			        <select data-default="<?=isset($duration)? $duration: '30' ?>" id="duration" class="form-control input-lg time-filter" >
			            <option value="7"><?=langline('account.dashboard.span.9') ?></option>
		                <option value="14"><?=langline('account.dashboard.span.10') ?></option>
			            <option value="30"><?=langline('account.dashboard.span.11') ?></option>
			            <option value="60"><?=langline('account.dashboard.span.12') ?></option>
			            <option value="90"><?=langline('account.dashboard.span.13') ?></option>
			            <option value="365"><?=langline('account.dashboard.span.14') ?></option>
			            <option value="730"><?=langline('account.dashboard.span.15') ?></option>
			            <option value="all"><?=langline('account.dashboard.span.16') ?></option>
			        </select>
			    </div>
			</div>

			<div class='row'>
				<div class='col-md-6'>
					<div class="panel panel-success">
					    <div class="panel-heading">
					        <div class="row">
					            <div class="col-xs-3 text-right">
					                <i class="fa fa-money fa-4x"></i>
					            </div>
					            <div class="col-xs-9 text-right">
					                <div class="huge"><?=get_currency()['symbol'].round_balance($total_links_earnings) ?></div>
					                <div><?=langline('account.dashboard.span.17') ?> (<?=get_currency()['name'] ?>)</div>
					            </div>
					        </div>
					    </div>
					</div>
				</div>
				<div class='col-md-6'>
					<div class="panel panel-warning">
					    <div class="panel-heading">
					        <div class="row">
					            <div class="col-xs-3 text-right">
					                <i class="fa fa-eye fa-4x"></i>
					            </div>
					            <div class="col-xs-9 text-right">
					                <div class="huge"><?=(int)$total_links_views ?></div>
					                <div><?=langline('account.dashboard.span.7') ?></div>
					            </div>
					        </div>
					    </div>
					</div>
				</div>
				<div class='col-md-6'>
					<div class="panel panel-info">
					    <div class="panel-heading">
					        <div class="row">
					            <div class="col-xs-3 text-right">
					                <i class="fa fa-chain-broken fa-4x"></i>
					            </div>
					            <div class="col-xs-9 text-right">
					                <div class="huge"><?=$total_links ?></div>
					                <div><?=langline('account.dashboard.span.18') ?></div>
					            </div>
					        </div>
					    </div>
					</div>
				</div>
				<div class='col-md-6'>
					<div class="panel panel-danger">
					    <div class="panel-heading">
					        <div class="row">
					            <div class="col-xs-3 text-right">
					                <i class="fa fa-chain-broken fa-4x"></i>
					            </div>
					            <div class="col-xs-9 text-right">
					                <div class="huge"><?=$total_banned_links ?></div>
					                <div><?=langline('account.dashboard.span.19') ?></div>
					            </div>
					        </div>
					    </div>
					</div>
				</div>
			</div>
			<div class='row'>
				<div class='col-lg-12'>
					<div class="panel panel-info">
						<div class="panel-heading"><b><i class='fa fa-lg fa-fw fa-area-chart'></i> <?=langline('account.dashboard.span.20') ?></b></div>
						<div class="panel-body">
							<canvas id="view-over-time" style="width: 100%; height: 300px"></canvas>
		                    <script>
		                        (() => {
		                        	"use strict"

		                        	let labels = <?=json_encode(array_map(function ($day) {
		                        	    return $day->created;
		                        	}, $views_over_time)) ?>

		                        	let data = <?=json_encode(array_map(function ($day) {
		                        	    return $day->total_views;
		                        	}, $views_over_time)) ?>

		                        	// Filling missing days & re-formating.
		                        	fillMissing(labels, data, 'YYYY-MM-DD')
		                        	labels = labels.map(day => moment(day, 'YYYY-MM-DD').format('MMM D'))

		                        	const ctx = document.getElementById('view-over-time').getContext('2d')
		                        	const myChart = new Chart(ctx, {
		                        	    type: 'line',
		                        	    data: {
		                        	        labels: labels,
		                        	        datasets: [{
		                        	            label: 'Views',
		                        	            data: data,
		                        	            lineTension: 0.2,
		                        	            backgroundColor: [
		                        	                'rgba(54, 162, 235, 0.2)',
		                        	                'rgba(140, 193, 82, 0.2)',
		                        	                'rgba(54, 162, 235, 0.2)',
		                        	                'rgba(255, 206, 86, 0.2)',
		                        	                'rgba(75, 192, 192, 0.2)',
		                        	                'rgba(153, 102, 255, 0.2)', // purpal
		                        	                'rgba(255, 159, 64, 0.2)'
		                        	            ],
		                        	            borderColor: [
		                        	                'rgba(54, 162, 235, 1)'
		                        	            ],
		                        	            borderWidth: 2
		                        	        }]
		                        	    },
		                        	    options: {
		                        	        responsive: true,
		                        	        scales: {
		                        	            y: {
		                        	                beginAtZero: true
		                        	            }
		                        	        },
		                        	    }
		                        	});
		                        })()
		                    </script>
						</div>
					</div>
					<br>
				</div>
			</div>

			<div class='row'>
				<div class='col-lg-12'>
					<div class="panel panel-success">
						<div class="panel-heading"><b><i class='fa fa-lg fa-fw fa-area-chart'></i> <?=langline('account.dashboard.span.29') ?></b></div>
						<div class="panel-body">
							<canvas id="earnings-over-time" style="width: 100%; height: 300px"></canvas>
		                    <script>
		                    	(() => {
		                    		"use strict"

		                    		let labels = <?=json_encode(array_map(function ($day) {
		                    		    return $day->created;
		                    		}, $views_over_time)) ?>

		                    		let data = <?=json_encode(array_map(function ($day) {
		                    		    return round_balance($day->total_earnings);
		                    		}, $views_over_time)) ?>

		                    		// Filling missing days & re-formating.
		                    		fillMissing(labels, data, 'YYYY-MM-DD')
		                    		labels = labels.map(day => moment(day, 'YYYY-MM-DD').format('MMM D'))

		                    		const ctx = document.getElementById('earnings-over-time').getContext('2d')
		                    		const myChart = new Chart(ctx, {
		                    		    type: 'line',
		                    		    data: {
		                    		        labels: labels,
		                    		        datasets: [{
		                    		            label: 'Earnings in <?=get_currency()['symbol'] ?>',
		                    		            data: data,
		                    		            lineTension: 0.2,
		                    		            backgroundColor: [
		                    		                'rgba(140, 193, 82, 0.2)',
		                    		                'rgba(54, 162, 235, 0.2)',
		                    		                'rgba(255, 206, 86, 0.2)',
		                    		                'rgba(75, 192, 192, 0.2)',
		                    		                'rgba(153, 102, 255, 0.2)', // purpal
		                    		                'rgba(255, 159, 64, 0.2)'
		                    		            ],
		                    		            borderColor: [
		                    		                'rgba(140, 193, 82, 1)',
		                    		            ],
		                    		            borderWidth: 2
		                    		        }]
		                    		    },
		                    		    options: {
		                    		        responsive: true,
		                    		        scales: {
		                    		            y: {
		                    		                beginAtZero: true
		                    		            }
		                    		        },
		                    		    }
		                    		});
		                    	})()
		                    </script>
						</div>
					</div>
					<br>
				</div>
			</div>

			<div class="row">
			    <div class="col-md-12">
			        <div class="panel panel-info">
			            <div class="panel-heading">
			                <b><i class="fa fa-map-marker fa-fw"></i> <?=langline('account.dashboard.span.21') ?></b>
			            </div> <!-- /.panel-heading -->

			            <div class="panel-body">
			                <script type="text/javascript">
			                  google.charts.load('current', {
			                    'packages':['geochart'],
			                  });
			                  google.charts.setOnLoadCallback(drawRegionsMap);

			                  function drawRegionsMap() {
			                    let data = google.visualization.arrayToDataTable([
			                      ['Country', 'Views'],
			                      <?php foreach ($view_per_geo as $k => $country): ?>
			                        ['<?=country($country->code)->getName() ?>', <?=$country->total_views ?>],
			                      <?php endforeach ?>
			                    ]);

			                    let options = {};

			                    let chart = new google.visualization.GeoChart(document.getElementById('regions_div'));

			                    chart.draw(data, options);
			                  }
			                </script>
			                <div id="regions_div" style="width: 100%; height: 400px"></div>
			            </div>
			        </div>
			    </div>
			    <div class="col-md-12">
			        <div class="panel panel-info">
			            <div class="panel-heading">
			                <b><i class="fa fa-fw fa-flag"></i> <?=langline('account.dashboard.span.22') ?></b>
			            </div>
			            <div class="panel-body">
			                <table class="table">
			                    <thead>
			                        <tr>
			                            <th><?=langline('account.dashboard.span.25') ?></td>
			                            <th><?=langline('account.dashboard.span.26') ?></td>
			                            <th><?=langline('account.dashboard.span.27') ?></td>
			                            <th><?=langline('account.dashboard.span.28') ?></td>
			                        </tr>
			                    </thead>
			                    <tbody>
			                        <?php foreach($top_countries as $k => $country): ?>
			                            <tr>
			                                <td>
			                                    <span title="<?=$country->name ?>">
			                                        <?=get_country_flag($country->code)?>
			                                    </span>
			                                </td>
			                                <td><?=$country->name ?></td>
			                                <td><?=$country->total_views ?></td>
			                                <td><?=get_currency()['symbol'].round_balance($country->earnings) ?></td>
			                            </tr>
			                        <?php endforeach ?>
			                    </tbody>
			                </table>
			            </div>
			        </div>
			    </div>
			</div>

			<div class="row">
				<div class="col-md-6">
				    <div class="panel panel-success">
				        <div class="panel-heading with-border">
				            <b><i class="fa fa-pie-chart fa-fw"></i> <?=langline('account.dashboard.span.23') ?></h3>
				        </div> <!-- /.panel-heading -->
				        <div class="panel-body">
				            <script type="text/javascript">
				                (() => {
				                	"use strict"

				                    google.charts.load('current', {'packages':['corechart']});
				                    google.charts.setOnLoadCallback(drawChart);

				                    function drawChart() {

				                    let data = google.visualization.arrayToDataTable([
				                        ['Browser', 'Visitors'],
				                        <?php foreach($top_browsers as $k => $browser): ?>
				                            <?="['$browser->browser', $browser->total_visitors ]," ?>
				                        <?php endforeach ?>
				                    ]);

				                    let options = {
				                      ...DefaultOptions,
				                    };

				                    let chart = new google.visualization.PieChart(document.getElementById('piechart2'));

				                    chart.draw(data, options);
				                    }
				                    window.addEventListener("resize", function (event) {
				                        let options = {
				                            width: '100%',
				                        };
				                        drawChart();
				                    });
				                })()
				            </script>
				            <div id="piechart2" style="width: 100%; height: 300px"></div>
				        </div>
				    </div>
				</div>
				<div class="col-md-6">
				    <div class="panel panel-success">
				        <div class="panel-heading with-border">
				            <b><i class="fa fa-pie-chart fa-fw"></i> <?=langline('account.dashboard.span.24') ?></b>
				        </div> <!-- /.panel-heading -->
				        <div class="panel-body">
				            <script type="text/javascript">
				                (() => {
				                	"use strict"

				                    google.charts.load('current', {'packages':['corechart']});
				                    google.charts.setOnLoadCallback(drawChart);

				                    function drawChart() {

				                    let data = google.visualization.arrayToDataTable([
				                        ['OS', 'Visitors'],
				                        <?php foreach($top_os as $k => $os): ?>
				                            <?="['$os->os', $os->total_visitors ]," ?>
				                        <?php endforeach ?>
				                    ]);

				                    let options = {
				                      ...DefaultOptions,
				                    };

				                    let chart = new google.visualization.PieChart(document.getElementById('piechart3'));

				                    chart.draw(data, options);
				                    }

				                    window.addEventListener("resize", function (event) {
				                        let options = {
				                            width: '100%',
				                        };

				                        drawChart();
				                    });
				                })()
				            </script>
				            <div id="piechart3" style="width: 100%; height: 300px"></div>
				        </div>
				    </div>
				</div>
			</div>
		</div>
	</div>
</div>
