<div class='container account'>
	<div class='row'>
		<?=$sidebar ?>
		<div class='col-md-9' dir='ltr'>
			<div dir='ltr'><h1><i class="fa fa-fw fa-puzzle-piece"></i> Developers API</h1><hr></div>
			<div class="panel panel-success">
				<div class="panel-heading"><h3 class="panel-title">My API Token:</h3></div>
				<div class="panel-body">
					<div class="row">
						<div class="col-sm-10">
							<code class="text-success"><b id="api-token"><?=$user->user_token ?></b></code>
						</div>
						<div class="col-sm-2">
							<button class="btn-primary btn-sm btn-block" id="refresh-token"><i class="fa fa-refresh fa-fw" aria-hidden="true"></i> <i>Refresh</i></button>
						</div>
					</div>
				</div>
			</div>

			<p>For developers prepared API which returns responses in JSON format.
Currently there is one method which can be used to shorten links on behalf of your account.
All you have to do is to send a GET request with your API token and URL Like the following:</p>

			<b><pre><?=base_url(); ?>api?token=<?=$user->user_token ?>&url=https://YourDistinationDomain.com</pre></b>

			A successful response looks like (e.g.):
			<b><pre>{"status":"success","message":"Done successfully","shortened_url":"<?=get_domains(0) ?>wykY"}</pre></b>

			A none successful response looks like (e.g.):
			<b><pre>{"status":"error","message":"invalid url"}</pre></b>

			<div class="alert alert-warning">
				<i class="fa fa-fw fa-info-circle"></i> The parameters <b>token</b> & <b>url</b> are required in order to shorten a link/URL.
			</div>
			<div class="panel panel-info">
				<div class="panel-heading">
					<h3 class="panel-title">Additional parameters:</h3>
				</div>
				<div class="panel-body">
					<table class="table">
						<thead>
							<tr>
								<th width="120px">Parameter</th>
								<th>Value type</th>
								<th>Default</th>
								<th>Usages!</th>
							</tr>
						</thead>
						<tbody>
							<tr>
								<td>title</td>
								<td><code>string</code></td>
								<td><code>null</code> (randomly generated, <br>e.g. <code>api-54246546</code>)</td>
								<td><b><pre>&title=YourTitleHere</pre></b></td>
							</tr>
							<tr>
								<td>domain</td>
								<td><code>integer</code></td>
								<td>
									<code>0</code> (default)<br>
									Available values:<br>
									<? foreach(get_all_domains() as $k => $domain) {
										echo "<code>$k</code> for <b>".$domain."</b><br>";
									} ?>
								</td>
								<td><b><pre>&domain=0</pre></b></td>
							</tr>
							<tr>
								<td>direct</td>
								<td><code>integer</code></td>
								<td>
									<code>0</code> (default)<br>
									Available values:<br>
									<code>0</code> direct redirection disabled.<br>
									<code>1</code> direct redirection enabled.
								</td>
								<td><b><pre>&direct=1</pre></b></td>
							</tr>
							<tr>
								<td>slug</td>
								<td><code>string</code></td>
								<td><code>null</code> (default: auto generated).</td>
								<td><b><pre>&slug=top-2023-video-games</pre></b></td>
							</tr>
							<tr>
								<td>seo-keywords</td>
								<td><code>string</code></td>
								<td><code>null</code> (default)</td>
								<td><b><pre>&seo-keywords=abc,jklm,etc</pre></b></td>
							</tr>
							<tr>
								<td>seo-desc</td>
								<td><code>string</code></td>
								<td><code>null</code> (default)</td>
								<td><b><pre>&seo-desc=this is a nice description</pre></b></td>
							</tr>
						</tbody>
					</table>
				</div>
			</div>
		</div>
	</div>
</div>
