<div class='container account'>
	<div class='row'>
		<?=$sidebar ?>
		<div class='col-md-9'>
			<div class='row'>
				<div id='title' class='col-md-7'>
					<h1><i class="fa fa-fw fa-link"></i> <?php langLine('account.mylinks.title') ?></h1>
				</div>
				<div class='col-md-5'>
					<br>
					<div id='text-left'>
						<form action='<?=base_url($page_path) ?>/mylinks/p/1' method='get'>
							<div class="input-group">
								<input type="text" class="form-control" name='s' placeholder="<?php langLine('account.mylinks.span.1') ?>"
									value='<?php if (isset($string)){echo htmlentities($string,ENT_QUOTES);}?>' >
								<span class="input-group-btn">
									<button class="btn btn-warning"><i class='fa fa-search'></i> <?php langLine('account.mylinks.search') ?></button>
								</span>
							</div>
						</form>
					</div>
				</div>
			</div>
			<hr>
			<div class='row'>
				<div class='col-md-12'>
				<?php if ($links->num_rows()): ?>
					<? foreach ($links->result_object() as $link): ?>
						<div class="panel panel-info">
							<div class="panel-heading">
								<a href='<?=get_domains($link->domain).$link->slug ?>' target='_blank'>
									<b><i class='fa fa-link fa-fw'></i> <?=$link->title ?></b>
								</a>
								<? if ($link->status == 1): ?>
									<span class='badge badge-success' title='<?=langLine('account.mylinks.span.7', false) ?>'><?=langLine('account.mylinks.span.8', false) ?></span>
								<? else: ?>
									<span class='badge badge-danger' title='<?=langLine('account.mylinks.span.9', false) ?>'><?=langLine('account.mylinks.span.10', false) ?></span>
								<? endif ?>

								<? if ($link->direct_redirection == 1): ?>
									<span class="badge badge-primary">Direct Redirection</span>
								<? endif; ?>
							</div>
							<div class="panel-body">
								<div class="row">
									<div class="col-md-10">
										<div class="row">
											<div class='col-md-6'>
												<span><?php langLine('account.mylinks.span.11') ?> :</span>
												<div class='input-group input-group-sm'>
													<span class='input-group-btn'>
														<button class='btn btn-secondary copy' type='button'>Copy</button>
													</span>
													<input class='form-control' dir='ltr' type='text' value='<?=get_domains($link->domain).$link->slug ?>' >
												</div>
											</div>

											<div class='col-md-6'>
												<span><?php langLine('account.mylinks.span.12') ?> :</span>
												<div class='input-group input-group-sm'>
													<span class='input-group-btn'>
														<button class='btn btn-secondary copy' type='button'>Copy</button>
													</span>
													<input class='form-control' dir='ltr' type='text'value='<?=htmlentities(decode($link->url), ENT_QUOTES) ?>' >
												</div>
											</div>
										</div>
									</div>
									<div class="col-md-2">
										<div class='action py-5'>
											<span class='btn btn-danger btn-sm deleteLink btn-block' id='<?=$link->id ?>' ><i class='fa fa-trash'></i><span>
										</div>
									</div>
								</div>
							</div>
							<div class="panel-footer">
								<div class="row">
									<div class="col-md-4 col-xs-12">
										<i class='fa fa-clock-o'></i> <b><?=date(get_config_item("time_format"), strtotime($link->created)) ?></b>
									</div>
									<div class="col-lg-2 col-md-2 col-xs-12">
										<i class='fa fa-eye fa-fw'></i> <b><?=intval($link->total_views) ?></b>
									</div>
									<div class="col-lg-2 col-md-2 col-xs-12">
										<b>#ID: <?=$link->id ?></b>
									</div>

									<div class="col-lg-2 col-md-3 col-xs-14">
										<b>Earnings: <?=get_currency()['symbol'].round_balance($link->total_earnings) ?></b>
									</div>
								</div>
							</div>
						</div>
					<? endforeach ?>

					<div class='row'>
						<div class='col-md-10'>
							<div>
								<?=pagination($total_items,$num_per_page,base_url($page_path.'/mylinks/p/'),'ar')?>
							</div>
						</div>
						<div class='col-md-2'>
							<br>
							<small>
								<span dir='rtl'><i>(<?=$total_items ?>) <?php langLine('account.mylinks.span.13') ?></i></span><br>
								<b dir='ltr'><?=$p."/".$all_pages." ".langLine('account.mylinks.span.14', false)." "; ?></b>
							</small>
							<br>
							<br>
						</div>
					</div>
				<? else: ?>
					<div class="text-center"><?=langLine('account.mylinks.span.3', false) ?></div>
				<? endif ?>
			</div>
			</div>
		</div>
	</div>
</div>
