<?php
use Sinergi\BrowserDetector\Browser;
$browser = new Browser();

$currency = get_currency();
?>
<script src='<?php echo base_url("assets/js/ajax.form.js"); ?>'></script>
<!-- recaptcha script -->
<script src='https://www.google.com/recaptcha/api.js?hl=ar'></script>
<div class='container account'>
	<div class='row'>
		<?php
		echo $sidebar;
		?>
		<div class='col-md-9'>
			<div class='msg' style='display: none;'></div>
			<div>
				<!-- Nav tabs -->
				<ul class="nav nav-tabs" role="tablist">
					<li role="presentation" class="active">
						<a href="#withdraw" aria-controls="withraw" role="tab" data-toggle="tab">
						<i class='fa fa-lg fa-credit-card'></i> <?php langLine('account.withdrawal.span.1') ?></a>
					</li>

					<li role="presentation">
						<a href="#history" aria-controls="history" role="tab" data-toggle="tab">
						<i class='fa fa-lg fa-history'></i> <?php langLine('account.withdrawal.span.2') ?></a>
					</li>
				</ul>

				<!-- Tab panes -->
				<div class="tab-content">
					<div role="tabpanel" class="tab-pane active" id="withdraw">
						<div class="row">
							<div class="col-md-5">
								<h3><?=langLine('account.withdrawal.span.3') ?></h3>
								<form method='POST' action='<?php echo base_url($page_path); ?>/ajax' id='updateWithdrawalMethod'>
									<div class='form-group'>
										<label><?=langLine('account.withdrawal.span.4') ?></label>
										<select name='withdrawal_method' class='form-control'>
											<option value='0'>--- <?=langLine('account.withdrawal.span.18') ?> ---</option>
											<?php foreach($withdrawal_methods as $method): ?>
												<option value='<?=$method->id ?>' ><?=$method->name ?></option>
											<?php endforeach ?>
										</select>
									</div>
									<div class="form-group">
										<label><?=langLine('account.withdrawal.span.5') ?> (<?=$currency['name'] ?>)</label>
										<? if ($browser->getName() === Browser::FIREFOX): ?>
											<input type="text" name="amount" class="form-control" value="<?=round($userdata['earnings'], 2) ?>">
										<? else: ?>
											<input type="number" name="amount" class="form-control" value="<?=round($userdata['earnings'], 2) ?>" max="<?=round($userdata['earnings'], 2) ?>" min="0" step="0.01">
										<? endif ?>
									</div>
									<div class="form-group">
										<label><?=langLine('account.withdrawal.span.6') ?></label>
										<textarea name="withdrawal_account" rows='5' class="form-control" placeholder="e.g. For PayPal, add your email here."></textarea>
									</div>
									<div class="form-group">
										<input type='hidden' name='tab' value='3' >
										<button type="submit" class="btn btn-secondary"><?=langLine('account.withdrawal.span.17') ?></button>
									</div>
								</form>
							</div>
							<div class='col-md-7'>
								<h3><?=langLine('account.withdrawal.span.7') ?></h3>
								<?php
								$currency = get_currency();
								?>
								<?php if ($withdrawal_methods): ?>
									<table class='table table-striped'>
										<thead>
											<tr>
												<th><?=langLine('account.withdrawal.span.8') ?></th>
												<th><?=langLine('account.withdrawal.span.9') ?></th>
												<th><?=langLine('account.withdrawal.span.10') ?></th>
											</tr>
										</thead>
										<tbody>
											<?php foreach($withdrawal_methods as $method): ?>
											<tr>
												<td><?=$method->name ?></td>
												<td><?="{$currency['symbol']}{$method->min_amount}" ?></td>
												<td><?=$method->description ?></td>
											</tr>
											<?php endforeach ?>
										</tbody>
									</table>
								<?php endif ?>
							</div>
						</div>
						<div class='col-md-12'>
							<h3><?=langLine('account.withdrawal.span.11') ?></h3>
							<table class="table table-striped table-hover">
								<thead>
									<tr>
										<th>ID</th>
										<th width="35%"><?=langLine('account.withdrawal.span.12') ?></th>
										<th><?=langLine('account.withdrawal.span.8') ?></th>
										<th><?=langLine('account.withdrawal.span.13') ?></th>
										<th><?=langLine('account.withdrawal.span.14') ?></th>
										<th><?=langLine('account.withdrawal.span.15') ?></th>
									</tr>
								</thead>
								<tbody>
								<tbody>
								<?php foreach($withdrawal_requests as $request): ?>
									<tr>
										<td><?=$request->id ?></td>
										<td><?=$request->withdrawal_account ?></td>
										<td><?=$request->method ?></td>
										<td><? echo "{$currency['symbol']}{$request->amount} ({$currency['name']})" ?></td>
										<td><b><?=get_req_status($request->status) ?></b></td>
										<td>
											<?php if ($request->status == 0): ?>
												<button class="btn btn-danger deleteWithdrawalReq" data-req-id="<?=$request->id ?>" ><i class="fa fa-trash-o"></i> <?=langLine('account.withdrawal.span.16') ?></button>
											<?php endif ?>
										</td>
									</tr>
								<?php endforeach ?>
								</tbody>
							</table>
						</div>
					</div>

					<div role="tabpanel" class="tab-pane" id="history">
						<div class='col-md-12'>
							<h3><?=langLine('account.withdrawal.span.19') ?></h3>
							<table class="table table-striped">
								<thead>
								<tr>
									<th>ID</th>
									<th width="40%"><?=langLine('account.withdrawal.span.12') ?></th>
									<th><?=langLine('account.withdrawal.span.8') ?></th>
									<th><?=langLine('account.withdrawal.span.13') ?></th>
									<th><?=langLine('account.withdrawal.span.14') ?></th>
									<th><?=langLine('account.withdrawal.span.20') ?></th>
								</tr>
								</thead>
								<tbody>
							<?php foreach($withdrawal_requests_history as $request): ?>
								<tr>
									<td><?=$request->id ?></td>
									<td><?=$request->withdrawal_account ?></td>
									<td><?=$request->method ?></td>
									<td><? echo "{$currency['symbol']}{$request->amount} ({$currency['name']})" ?></td>
									<td><b><?=get_req_status($request->status) ?></b></td>
									<td><?=date(get_config_item('time_format'), strtotime($request->created)) ?></td>
								</tr>
							<?php endforeach ?>
								</tbody>
							</table>
						</div>
					</div>

				</div>
			</div>
		</div>
	</div>
</div>
