<!DOCTYPE html>
<html lang="ar">
<head>
	<meta charset="UTF-8">
	<title><?php echo $title; ?></title>
	<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta http-equiv="x-ua-compatible" content="ie=edge">
    <meta name="keywords" content="<?=(isset($link))? $link->keywords : "" ?>">
    <meta name="description" content="<?=(isset($link))? $link->description : "" ?>">

    <!-- for social network -->
    <meta type="og:title" content="<?php echo $title; ?>" >
    <meta type="og:description" content="<?=(isset($link))? $link->description : "" ?>" >
    <meta type='og:image' content="<?php echo base_url(); ?>assets/img/logo.png" >

    <!-- show favicon -->
    <?php
    echo get_icon();
    ?>

    <!-- Load jQuery library -->
    <script type="text/javascript" src="<?php echo base_url(); ?>assets/js/jquery.min.js"></script>
    <script type="text/javascript" src="<?php echo base_url(); ?>assets/js/plugin.js"></script>

    <!-- fonts -->
    <link href="http://fonts.googleapis.com/earlyaccess/droidarabickufi.css" rel="stylesheet">
    <link href="https://fonts.googleapis.com/css2?family=Nunito:ital,wght@0,200;0,400;0,600;0,800;1,200;1,400;1,600;1,800&display=swap" rel="stylesheet">

    <!-- Bootstrap core CSS -->
    <link href="<?php echo base_url(); ?>assets/css/bootstrap/css/bootstrap.css" rel="stylesheet">
    <link href="<?php echo base_url(); ?>assets/css/font-awesome/font-awesome.min.css" rel="stylesheet">

    <!-- Load the style of the site -->
    <link href="<?php echo base_url(); ?>assets/css/style.css?<?=cache_hash() ?>" rel="stylesheet">
    <link href="<?php echo base_url(); ?>assets/css/go-style.css?<?=cache_hash() ?>" rel="stylesheet">

    <!-- for RTL theme -->
    <?php if (config_item('validLang')['isRTL']){ ?>
    <link href="<?php echo base_url(); ?>assets/css/bootstrap/css/bootstrap-rtl.css?<?=cache_hash() ?>" rel="stylesheet">
    <link href="<?php echo base_url(); ?>assets/css/style-rtl.css?<?=cache_hash() ?>" rel="stylesheet">
    <?php } ?>

    <!-- Theme override -->
    <link href="<?php echo base_url(); ?>assets/css/override-theme.css?<?=cache_hash() ?>" rel="stylesheet">

    <!-- Head codes like google analytics -->
    <?php
    if (get_config_item('go_head_code') != '')
    {
    	echo get_config_item('go_head_code');
    }
    ?>
</head>
<body>
    <span data-base-url="<?php echo base_url() ?>" class="base-url"></span>
    <header>
        <nav class="navbar navbar-default navbar-static-top">
          <div class="container-fluid container">
            <!-- Brand and toggle get grouped for better mobile display -->
            <div class="navbar-header">
              <a class="navbar-brand <?php if (config_item("show_logo") == 1){echo 'site-logo-img';} ?>" href="<?php echo my_base_url(); ?>"><?php echo get_logo(); ?></a>
            </div>


            <!-- Collect the nav links, forms, and other content for toggling -->
            <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
              <ul class="nav navbar-nav">
                <?php
                  $s = $this->cms_model->getPages('header');
                  if ($s->num_rows() != 0)
                  {
                    echo "<li><a href='".my_base_url()."'>".langLine('theme.header.home', false)."</a></li>";
                    foreach ($s->result_array() as $row)
                    {
                      echo "<li><a href='".my_base_url("p/".$row['slug'])."'>".ucfirst($row['title'])."</a></li>";
                    }
                  }
                ?>
              </ul>

              <ul class="nav navbar-nav navbar-right">
                  <li><a href="<?php echo my_base_url(); ?>login" class="active-2"><i class="fa fa-fw fa-sign-in"></i> <?php langLine('theme.header.login'); ?></a></li>
                  <li class='divider'></li>
                  <li><a href="<?php echo my_base_url(); ?>register" class="active"><i class="fa fa-fw fa-user-plus"></i> <?php langLine('theme.header.register'); ?></a></li>
              </ul>

            </div><!-- /.navbar-collapse -->
          </div><!-- /.container-fluid -->
        </nav>
    </header>
    <section>

