$(() => {
	"use strict"

	function getBaseURL()
	{
		return location.href.split('adminpanel')[0] + "adminpanel/"
	}

	function getAjaxURL()
	{
		return location.href.split('adminpanel')[0] + "adminpanel/ajax"
	}

	/*=========================== Delete Announcement ==============================*/
	document.addEventListener('click', (e) => {
		if (e.target.nodeName == 'A' && e.target.classList.contains('deleteAnnoucement'))
		{
			const ann_id = e.target.getAttribute('data-id')
			const tr = e.target.parentElement.parentElement

			if (confirm('Are you sure you want to delete this announcement?'))
			{
				fetch(getAjaxURL(), {
					method: 'POST',
					headers: {
						'Content-Type': 'application/x-www-form-urlencoded',
					},
					body: `delete_ann=true&ann_id=${ann_id}`
				})
				.then(req => req.json())
				.then(data => {
					if (data.deleted)
						tr.remove()
					alert(data.message)
				}).catch(err => console.log(err))
			}
		}
	})

	/*=========================== auto copy the urls ==============================*/

	$('.copy').on('click', function (e){
		let btn = e.target
		let children = btn.parentElement.parentElement.children;
		let input = children[1];
		//console.log(children);

		input.select();
		document.execCommand('copy');

		btn.classList.replace('btn-primary', 'btn-success');
		btn.textContent = 'Copied';
		clearSelection();

		setTimeout((function (){
			btn.textContent = 'Copy';
			btn.classList.replace('btn-success', 'btn-primary');
		}), 2000);
	});

	// clear selected items
	function clearSelection() {
	    if ( document.selection ) {
	        document.selection.empty();
	    } else if ( window.getSelection ) {
	        window.getSelection().removeAllRanges();
	    }
	}

	/*================== Show tooltip =============================*/
	$('[data-toggle="tooltip"]').tooltip();

	/*================== delete user by id ========================*/
	$(".delete").on('click', function (e){
		let id = $(this).attr('id');
	    let tr = $(this).parents('tr');

	    //alert($.url());

	    if(confirm("Are you sure you want to delete this user (id: "+id+") ?")){
	       $.ajax({
	       		url: getAjaxURL(),
	       		type: 'POST',
	       		data: "deleteUser=1&id="+id,
	       		success: function(r,s,xhr)
	       		{
	       			if (s == "success")
	       			{
	       				$(tr).slideUp('slow',function (){
	       					alert(r);
	       				});
	       			}
	       			else
	       			{
	       				alert(xhr.responseText);
	       			}
	       		},
	       });
	    }
	    else
	    {
	        return false;
	    }
	});


	/*================ Delete profile image =================*/

	$(".DeleteProfile").on('click', function (){
		let token = $(this).attr('id');

		if (confirm("Are you sure to Delete this profile image ?"))
		{
			$.ajax({
				url: getAjaxURL(),
				type: 'POST',
				data: "delete_image=1&token="+token,
				success: function (r,s,xhr)
				{
					if (s == 'success')
					{
						alert(r);
					}
				},
                error: function (xhr)
                {
                    alert(xhr.statusText);
                },
			});
		}
		else
		{
			return false;
		}
	});

	/*================ update profile data from admin =================*/
	$('#updateProfileUser').autosubmit('.msg','Saving ...');

	/*===================== Delete pages ======================*/

	$(".deletePage").on('click', function (){
	    let id = $(this).attr('id');
	    let tr = $(this).parents('tr');

	    if(confirm("Are you sure you want to delete this Page (id: "+id+")?"))
	    {
	       $.ajax({
	            url: getAjaxURL(),
	            type: 'POST',
	            data: "deletePage=1&id="+id,
	            success: function(r,s,xhr)
	            {
	                if (s == "success")
	                {
	                    $(tr).slideUp('slow',function (){
	                        alert(r);
	                    });
	                }
	            },
	            error: function (xhr)
	            {
	                alert(xhr.statusText);
	            },
	       });
	    }
	    else
	    {
	        return false;
	    }
	});

	/*===================== Delete Withdrawal Method ======================*/
	$(".deleteWithdrawalMethod").on('click', function (){
	    let id = $(this).attr('id');
	    let tr = $(this).parents('tr');

	    if(confirm("Deleting a withdrawal method is not recommended, you could deactivate it instead. \n\nNo, I know what I'm doing, \njust delete this withdrawal method (id: "+id+")?"))
	    {
	       $.ajax({
	            url: getAjaxURL(),
	            type: 'POST',
	            data: "deleteWithdrawalMethod=1&id="+id,
	            success: function(r,s,xhr)
	            {
	                if (s == "success")
	                {
	                    $(tr).slideUp('slow',function (){
	                        alert(r);
	                    });
	                }
	            },
	            error: function (xhr)
	            {
	                alert(xhr.statusText);
	            },
	       });
	    }
	    else
	    {
	        return false;
	    }
	});

	/*===================== Delete Withdrawal Request ======================*/
	$(".deleteWithdrowRequest").on('click', function (){
	    let id = $(this).attr('id');
	    let tr = $(this).parents('tr');

	    if(confirm("Deleting a withdrawal request is not recommended, you cound cancel it instead. \n\nNo, I know what I'm doing, \njust delete this withdrawal request (id: "+id+")?"))
	    {
	       $.ajax({
	            url: getAjaxURL(),
	            type: 'POST',
	            data: `deleteWithdrowRequest=1&id=${id}`,
	            success: function(r,s,xhr)
	            {
	                if (s == "success")
	                {
	                    $(tr).slideUp('slow',function (){
	                        alert(r);
	                    });
	                }
	            },
	            error: function (xhr)
	            {
	                alert(xhr.statusText);
	            },
	       });
	    }
	    else
	    {
	        return false;
	    }
	});

	/*===================== Change Withdrawal Request Status ======================*/
	$(".statusSelector").on('change', (e) => {
		let status_id = $(e.target).val()
	    let tr = $(e.target).parents('tr');
		tr.find('.saveWithdrowRequestStatus').attr('data-status-id', status_id)
	})

	$(".saveWithdrowRequestStatus").on('click', function (){
	    let id = $(this).attr('id');
	    let status_id = $(this).attr('data-status-id');
	    let tr = $(this).parents('tr');

		$.ajax({
		    url: getAjaxURL(),
		    type: 'POST',
		    data: `saveWithdrowRequestStatus=1&id=${id}&status_id=${status_id}`,
		    success: function(r,s,xhr)
		    {
		        if (s == "success")
		        {
		        	alert(r)
		        }
		    },
		    error: function (xhr)
		    {
		        alert(xhr.statusText);
		    },
		});

	});
	/*======================= Edit the page data =========================*/
	$('#editPage').autosubmit('.msg','Saving ...');

	/*========================= upload logo adn icon ============================*/
	$(".upload").mouseenter(function(){
		$(this).children('.choose-image').show();
	});

	$(".upload").mouseleave(function(){
		$(this).children('.choose-image').hide();
	});

	$(".uploadLogoImage").change(function (){
		let input = $(this);
		let span = $(this).parents('.upload').children('.progress');
		let dataspan = span.html();
		let img = $(this).parents('.upload').children('img');

		$(this).parents('form').ajaxForm({
			beforeSend: function ()
			{
				$('.uploadMsg').hide();
				span.show();
			},
			uploadProgress: function (a,b,c,d)
			{
				span.html("<i class='fa fa-upload'></i> "+d+'%');
			},
			success: function (r,s,xhr)
			{
				//alert(r);
				$('.uploadMsg').html(r).slideDown(function (){
					span.fadeOut().html(dataspan);

					let src = img.attr('src');
					img.attr('src',src+'?m='+Math.random());
				});
				input.val('');
			},

		}).submit();
	});

	/*======================== Update settings data of the website ==============================*/
	$('.optionForm').autosubmit('.msg','Saving ...');

	/*====================== Edit link ============================*/
	$('#edit_link').autosubmit('.msg','Saving ...');

	/*================== delete link by id ========================*/
	$(".delete_link").on('click', function (){
		let id = $(this).attr('id');
	    let box = $(this).parents('.panel');

	    if(confirm("Are you sure you want to delete this link (id: "+id+") ?")){
	       $.ajax({
	       		url: getAjaxURL(),
	       		type: 'POST',
	       		data: "deleteLink=1&id="+id,
	       		success: function(r,s,xhr)
	       		{
	       			if (s == "success")
	       			{
	       				$(box).slideUp('slow',function (){
	       					alert(r);
	       					$(this).html('');
	       				});
	       			}
	       			else
	       			{
	       				alert(xhr.responseText);
	       			}
	       		},
	       });
	    }
	    else
	    {
	        return false;
	    }
	});

	/*===================== Delete language ======================*/

	$(".deleteLang").on('click', function (){
	    let id = $(this).attr('id');
	    let tr = $(this).parents('tr');

	    if(confirm("Are you sure you want to delete this language (ID: "+id+")?\nremember, the translated files will be removed."))
	    {
	       $.ajax({
	            url: getAjaxURL(),
	            type: 'POST',
	            data: "deleteLang=1&id="+id,
	            success: function(r,s,xhr)
	            {
	                if (s == "success")
	                {
	                    $(tr).slideUp('slow',function (){
	                        alert(r);
	                    });
	                }
	            },
	            error: function (xhr)
	            {
	                alert(xhr.statusText);
	            },
	       });
	    }
	    else
	    {
	        return false;
	    }
	});

	/*===================== wysihtml5 ======================*/
	$('#some-textarea').wysihtml5();
	$('.some-textarea').wysihtml5();

	/*========= Enable Main Domain Protection =========*/
	const main_domain_protection_toggle = document.querySelector('#domain-protection')
	const main_domain_protection_status = document.querySelector('#domain-protection-status')

	if (main_domain_protection_toggle)
	{
		main_domain_protection_toggle.addEventListener('click', () => {
			swal({
				title: "Are you sure?",
				text: `
				- Ensure adding at least one Custom Domain before enabling the Protection.
				- Once you enable the Protection, the main domain cannot be used for links shortening.
				`,
				icon: "warning",
				buttons: true,
				dangerMode: true
			}).then(will_enable => {
				if (will_enable)
				{
					fetch(getBaseURL() + 'custom_domains?change=domain-protection')
					.then(res => res.json())
					.then(data => {
						if (data.enabled)
						{
							main_domain_protection_toggle.innerText = 'Disable'
							main_domain_protection_status.innerHTML = '<span class="badge label-success">On</span>'
						}
						else
						{
							main_domain_protection_toggle.innerText = 'Enable'
							main_domain_protection_status.innerHTML = '<span class="badge label-secondary">Off</span>'
						}

						swal({
							title: data.message,
							icon: data.status
						})
					}).catch(err => {
						swal({
							title: err,
							icon: "warning"
						})
					})

				}
			})

		})
	}

	/*========= Delete Ad Placement by ID =========*/
	const deleteAdButtons = document.querySelectorAll('.deleteAd')

	if(deleteAdButtons)
	{
		deleteAdButtons.forEach((button) => {
			button.addEventListener('click', (e) => {
				console.log('clicked')
				const button = e.target
				const tr = button.parentElement.parentElement

				if (button)
				{
					let ad_id = button.getAttribute('data-id')

					swal({
						title: `Are you sure you want to delete this Ad Placement (#${ad_id})?`,
						icon: "warning",
						buttons: ['No', 'Yes'],
						dangerMode: true
					}).then(will_enable => {
						if (will_enable)
						{
							fetch(getBaseURL() + 'ads/delete/' + ad_id)
							.then(res => res.json())
							.then(data => {
								if (data.deleted)
								{
									swal({
										title: data.message,
										icon: 'success'
									})
									if (tr)
										tr.remove()
								}
								else
								{
									swal({
										title: data.message,
										icon: "warning"
									})
								}
							}).catch(err => {
								swal({
									title: err,
									icon: "warning"
								})
							})
						}
					})
				}
			})
		})
	}

	/*========= Set Default Theme Colors =========*/
	document.querySelectorAll("input[type=color]")?.forEach(input => {
	    input.value = HSLToHex(...input.getAttribute('default-value').split(',').map(v => parseInt(v)))
	})

	/*========= Save theme =========*/
	const saveThemeForm = document.querySelector('#save-theme-form')

	if (saveThemeForm)
	{
		saveThemeForm.addEventListener('submit', (e) => {
			e.preventDefault()
			let primary_color = document.querySelector('input[name=primary-color]')
			let secondary_color = document.querySelector('input[name=secondary-color]')

			let dashboard_primary_color = document.querySelector('input[name=dashboard-primary-color]')
			let dashboard_secondary_color = document.querySelector('input[name=dashboard-secondary-color]')
			let dashboard_navbar_color = document.querySelector('input[name=dashboard-navbar-color]')

			let home_image_jumbotron = document.querySelector('input[name=home_image_jumbotron]')
			let home_image_1 = document.querySelector('input[name=home_image_1]')
			let home_image_2 = document.querySelector('input[name=home_image_2]')
			let home_image_3 = document.querySelector('input[name=home_image_3]')
			let home_image_4 = document.querySelector('input[name=home_image_4]')

			// convert colors: HEX to HSL
			primary_color = hexToHSL(primary_color.value, true)
			secondary_color = hexToHSL(secondary_color.value, true)
			dashboard_primary_color = hexToHSL(dashboard_primary_color.value, true)
			dashboard_secondary_color = hexToHSL(dashboard_secondary_color.value, true)
			dashboard_navbar_color = hexToHSL(dashboard_navbar_color.value, true)

			home_image_jumbotron = home_image_jumbotron.value
			home_image_1 = home_image_1.value
			home_image_2 = home_image_2.value
			home_image_3 = home_image_3.value
			home_image_4 = home_image_4.value

			let payload = {
				primary_color,
				secondary_color,

				dashboard_primary_color,
				dashboard_secondary_color,
				dashboard_navbar_color,

				home_image_jumbotron,
				home_image_1,
				home_image_2,
				home_image_3,
				home_image_4
			}

			fetch(getBaseURL() + 'theme/save', {
				method: 'POST',
				headers: {
					'Content-Type': 'application/json'
				},
				body: JSON.stringify(payload)
			}).then(res => res.json())
			.then(data => {
				if (data.success)
				{
					swal({
						title: data.message,
						icon: 'success'
					}).then(() => {
						location.reload();
					})
				}
				else
				{
					swal({
						title: 'Oops! Something went wrong!',
						icon: 'warning'
					})
				}
			}).catch(err => {
				swal({
					title: err,
					icon: 'warning'
				})
			})
		})
	}


	/*========= Set Default value for all countries (Payout rates) =========*/

	const payoutRatesForm = document.querySelector(".payout-rates-form")
	const resetButton = document.querySelector("#reset-payout-rates")
	let forms = []

	if (resetButton)
	{
		// collect forms
		forms = payoutRatesForm.querySelectorAll("input.country-input")

		resetButton?.addEventListener("click", (e) => {
			e.preventDefault()

			const input = document.createElement("input")
			input.type = "number"
			input.value = 0.4
			input.step = 0.1
			input.min = 0
			input.className = "form-control swal-content__input"

			swal({
				title: "Set a payout rate for all countries:",
				content: input,
				buttons: ["Cancel", {
					text: "Save",
					closeModel: false
				}]
				/*button: {
					text: "Save",
					closeModel: false
				}*/
			}).then((value) => {
				if (value)
				{
					Array.from(forms).map(country_input => {
						country_input.value = input.value
					})
					payoutRatesForm.submit()
				}
			})
		})
	}


}); // end

