var _ = [];			// Global variable
var BASE_URL = "";	// Global variable

(($) => {
	"use struct"

	window.addEventListener('load', function (e){
		BASE_URL = document.querySelector('span[data-base-url]').getAttribute('data-base-url').trim()
		loadTranslation()

		$('#sendMsg').autosubmit('.msg','<i class="fa fa-spin fa-spinner"></i> Sending ...');

		addEvents();
	})

	function loadTranslation()
	{
		fetch(BASE_URL+'ajax/jsAjaxStrings').then(res => res.json()).then(data => _ = data)
	}

	function addEvents()
	{
		handleCountdown()
		changeLanguage()
		navbar_right_fix()
	}

	function changeLanguage()
	{
		let select = document.getElementById('lang');

		if (select)
		{
			select.addEventListener('change', function (){
				window.location.href = '?lang='+this.value;
			});
		}
	}

	// set default values from 'select'
	const selectList = Array.from(document.querySelectorAll("select[data-default]"))
	selectList.map(select => {
		Array.from(select.querySelectorAll('option')).map(opt => {
			if (opt.getAttribute('value') === select.getAttribute('data-default'))
	        	opt.setAttribute("selected", "")
		})
	})

	// handle the countdown.
	function handleCountdown()
	{
		const btn = document.querySelector('#go-button')
		const countdown = document.querySelector('.countdown-circle')

		let prefentClick = (e) => e.preventDefault()
		if (btn)
		{
			btn.addEventListener('click', prefentClick)

			if (!countdown)
				return null

			let maxCountDown = parseInt(countdown.getAttribute('data-countdown'))

			let interval = setInterval(() => {
				// stop the countdown
				if (maxCountDown === 0)
					clearInterval(interval)

				// decrease the countdown
				countdown.innerText = maxCountDown

				// activate the button
				if (!maxCountDown)
				{
					btn.classList.remove('disabled')
					btn.innerText = _['ajax.str.8']
					btn.removeEventListener('click', prefentClick)
				}

				maxCountDown--
			}, 1000) // refresh every second
		}
	}

	// fixing navbar-right
	function navbar_right_fix()
	{
		let right_navbar = document.querySelector('.navbar-right')
		let navbar_collapse = document.querySelector('.navbar-collapse')
		let navbar_nav = document.querySelector('.navbar-nav')
		let navbar_header = document.querySelector('.navbar-header')

		function set_navbar_fix() {
			let right_navbar = document.querySelector('.navbar-right')
			if (right_navbar)
			{
				right_navbar_sum = Array.from(right_navbar.children, (child) => child.offsetWidth).reduce((a, i) => a+i, 0)

				if (navbar_collapse.clientWidth < navbar_nav.offsetWidth + right_navbar_sum + navbar_header.offsetWidth)
				{
					// add 'navbar-right-fix' class fix.
					if (!right_navbar.classList.contains('navbar-right-fix'))
					{
						right_navbar.classList.add('navbar-right-fix')
					}
				}
				else
				{
					if (right_navbar.classList.contains('navbar-right-fix'))
					{
						right_navbar.classList.remove('navbar-right-fix')
					}
				}
			}
		}

		// run for the first time set_navbar_fix
		set_navbar_fix()
		window.addEventListener('resize', set_navbar_fix)
	}

})(jQuery)
