(function ($){
	"use strict"

	/*------------ navbar scroled ------------*/
	window.onscroll = function (){

		// add check the navbar theme
		changeNavbarTheme();
	};

	// change the theme of navbar onscrolling
	function changeNavbarTheme()
	{
		let navbar = document.querySelector('.navbar');

		if (window.pageYOffset < 10 && navbar.classList.contains('navbar-scrolled'))
		{
			// remove class
			navbar.classList.remove('navbar-scrolled');
		}
		else if (window.pageYOffset > 10 && !navbar.classList.contains('navbar-scrolled'))
		{
			// add class
			navbar.classList.add('navbar-scrolled');
		}
	}

	$.url = function ()
	{
		let protocol = window.location.protocol;
		let hostname = window.location.hostname;
		let pathname = window.location.pathname;
		let search   = window.location.search;
		let hash     = window.location.hash;

		let url = protocol+'//'+hostname+pathname;
		//console.log(path);
		return url;
	};

	$.fn.autosubmit = function(Msg, btnString='', successCallback=() => {})
	{
		this.submit(function(e) {

			e.preventDefault();

			const form = $(this);
			//let form = $(e.target);
			const btn = form.find('button');
			let btndata = btn.html();

			if (btnString == '')
			{
				btnString = btndata;
			}

			$.ajax({
				url: form.attr('action'),
				type: form.attr('method'),
				data: form.serialize(),
				beforeSend: function ()
				{
					$(Msg).slideUp();
					btn.attr("disabled","disabled").html(btnString);
				},
				success: function (r,s,xhr)
				{
					if (s == 'success')
					{
						$(Msg).html(r).slideDown('slow',function (){
							btn.removeAttr('disabled').html(btndata);
						});
						successCallback(form, btn)
					}
				},
				error: function (xhr)
				{
					alert(`Something went wrong, please try again. (${xhr.status})!`);
				},
			});
		})
		return false;
	}

})(jQuery);
