#!/bin/bash

# Installing Composer for PHP
php -r "copy('https://getcomposer.org/installer', 'composer-setup.php');"
php composer-setup.php install
php -r "unlink('composer-setup.php');"

echo "Installing PHP dependencies..."
php composer.phar update && php composer.phar -n --no-cache install

# Downloading 'GeoLite2-City.mmdb' file (needed for country flags).
echo "Downloading 'GeoLite2-City.mmdb'..."
curl -sSL https://mr4web.com/resources/GeoLite2-City.mmdb -o ./uploads/GeoLite2-City.mmdb

# Fixing files and folders permissions
echo "Fixing files & folders permissions..."
find . -type d -exec chmod 755 {} \;
find . -type f -exec chmod 644 {} \;
chmod +x ./vendor/doctrine/migrations/bin/doctrine-migrations & chmod +x ./vendor/bin/doctrine-migrations

# Run migrations (for database)
if [[ $1 != "--no-migrations" ]]
then
	echo "Running migrations..."
	./vendor/bin/doctrine-migrations migrate -n
fi

# Do Some clean up (remove empty files)
find . -empty -delete
